#include <bits/stdc++.h>

#define fi(n) for (int i = 0; i < int(n); i++)
#define fj(n) for (int j = 0; j < int(n); j++)
#define fk(n) for (int k = 0; k < int(n); k++)
#define f1(x) for (auto &i1 : x)
#define f2(x) for (auto &i2 : x)
#define f3(x) for (auto &i3 : x)
#define all(x) std::begin(x), std::end(x)

using namespace std;

using ll = int64_t;
using ull = uint64_t;
using ld = long double;

constexpr ll MOD = 1'000'000'007;

struct node {
	int mn = INT_MAX;
	int mx = INT_MIN;
	int key = -1;
	int cnt = -1;
	int l = -1;
	int r = -1;
	int parent = -1;
	int depth = -1;
};

vector<node> tree;

tuple<int, int, int> dfs(int v, int d = 0)
{
	if (v == -1) {
		return { INT_MAX, INT_MIN, 0 };
	}
	auto rl = dfs(tree[v].l, d + 1);
	auto rr = dfs(tree[v].r, d + 1);
	tree[v].mn = min({ tree[v].key, get<0>(rl), get<0>(rr) });
	tree[v].mx = max({ tree[v].key, get<1>(rl), get<1>(rr) });
	tree[v].cnt = 1 + get<2>(rl) + get<2>(rr);
	tree[v].depth = d;
	return { tree[v].mn, tree[v].mx, tree[v].cnt };
}

bool includes(node &n, int l, int r)
{
	return n.mn <= l && n.mx >= r;
}

int updateSupernode(int v, int l, int r)
{
	node &n = tree[v];
	if (includes(n, l, r)) {
		return v;
	}
	if (n.parent == -1) {
		return v;
	}
	return updateSupernode(n.parent, l, r);
}

int supernode;

int lookup(int v, int l, int r)
{
	if (v == -1) {
		return 1;
	}
	node &n = tree[v];
	if (includes(n, l, r)) {
		supernode = v;
	}
	if (l <= n.mn && n.mx <= r) {
		return 1;
	}
	if (n.mx < l || r < n.mn) {
		return 1;
	}
	int res = 1;
	res += lookup(n.l, l, r);
	res += lookup(n.r, l, r);
	return res;
}

int main(int argc, char *argv[])
{
#ifdef OFFLINE_JUDGE
	(void) argc; (void) argv;
	freopen("/home/sven/progs/acm/input.txt", "r", stdin);
#endif
	cin.sync_with_stdio(false);
	cout.sync_with_stdio(false);
	cin.tie(nullptr);

	vector<int> coords;

	int n;
	cin >> n;
	tree.resize(n);
	tree[0].depth = 0;
	fi(n) {
		int l, r, k;
		cin >> l >> r >> k;
		tree[i].key = k;
		coords.emplace_back(k);
		if (l != 0) {
			tree[i].l = l - 1;
			tree[l - 1].parent = i;
		}
		if (r != 0) {
			tree[i].r = r - 1;
			tree[r - 1].parent = i;
		}
	}

	int q;
	cin >> q;
	vector<tuple<int, int, int> > queries(q);
	fi(q) {
		cin >> get<0>(queries[i]) >> get<1>(queries[i]);
		get<2>(queries[i]) = i;
		coords.emplace_back(get<0>(queries[i]));
		coords.emplace_back(get<1>(queries[i]));
	}

	sort(all(coords));
	coords.erase(unique(all(coords)), coords.end());

	f1(tree) {
		i1.key = int(lower_bound(all(coords), i1.key) - coords.begin());
	}
	dfs(0);

	f1(queries) {
		int &a = get<0>(i1);
		int &b = get<1>(i1);
		a = int(lower_bound(all(coords), a) - coords.begin());
		b = int(lower_bound(all(coords), b) - coords.begin());
	}

	constexpr int BSIZE = 1000;

	sort(all(queries), [](auto &a, auto &b) {
		int ba = get<0>(a) / BSIZE;
		int bb = get<0>(b) / BSIZE;
		if (ba == bb) {
			return get<1>(a) < get<1>(b);
		} else {
			return ba < bb;
		}
	});

	vector<int> ans(q);
	fi(q) {
		auto &qu = queries[i];
		int l = get<0>(qu);
		int r = get<1>(qu);
		int id = get<2>(qu);
		supernode = updateSupernode(supernode, l, r);
		//cout << id << ' ' << supernode << endl;
		int a = 2 * tree[supernode].depth;
		a += lookup(supernode, l, r);
		ans[id] = a;
	}

	f1(ans) {
		cout << i1 << endl;
	}

	return 0;
}
