import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class C {
    static List<List<Integer>> children = Stream.generate(() -> new ArrayList<Integer>()).limit(20).collect(Collectors.toList());
    static int[] parent = new int[20];
    static Map<Integer, Set<Integer>> stateTree = new HashMap<>(); //state -> parentState;
    static List<Integer> used;
    static List<Integer> height;
    static List<Integer> newParents;

    static int mxWow = -1;
    static List<Integer> arr = new ArrayList<>();


    static void processState(int currentState, int n) {
        if ((currentState & 1) == 0) return;

        for (int j = 1; j < n; j++) {
            int mask = (1 << j);
            int tryParentState = currentState ^ mask;
            if (stateTree.containsKey(tryParentState)) {
                boolean can = true;
                if ((currentState & mask) == mask) { // there was bit set to one
                    for (int i = 0; i < children.get(j).size(); i++) {
                        int child = children.get(j).get(i);
                        if (((1 << child) & currentState) != 0) {
                            can = false;
                            break;
                        }
                    }
                } else {
                    int par = parent[j];
                    if (((1 << par) & currentState) == 0) {
                        can = false;
                    }
                }

                //currentState == valid state
                if (can) {
                    stateTree.compute(currentState, (k, v) -> {
                        if (v == null) {
                            return new LinkedHashSet<>(List.of(tryParentState));
                        } else {
                            v.add(tryParentState);
                            return v;
                        }
                    });
                }
            }
        }
    }

    static int dfs(int v, int p, int depth, List<Integer> temp) {
        if (used.get(v) == 1) {
            return depth;
        }
        used.set(v, 1);
        temp.add(v);
        if (temp.size() > arr.size()) {
            arr = new ArrayList<>(temp);
        }
        /*if (depth >= height.get(v)) {
            height.set(v, depth);
            newParents.set(v, p);
        }*/
        var downs = stateTree.get(v);
        for (var to : downs) {
            int newDepth = dfs(to, v, depth + 1, temp);
        }
        temp.remove(temp.size() - 1);
        used.set(v, 0);
        return height.get(v);
    }

    static List<Integer> buildSeq() {
        int mx = -1;
        int vertex = -1;
        for (int i = 0; i < height.size(); i++) {
            if (height.get(i) > mx) {
                mx = height.get(i);
                vertex = i;
            }
        }

        List<Integer> list = new ArrayList<>();
        while (vertex != 1) {
            list.add(vertex);
            vertex = newParents.get(vertex);
        }
        list.add(1);
        return list;
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        for (int i = 1; i < n; i++) {
            int pi = sc.nextInt();
            --pi;
            parent[i] = pi;
            children.get(pi).add(i);
        }

        stateTree.put(1, null);
        int finalState = (1 << n) - 1;
        for (int currentState = 1; currentState <= finalState; currentState++) {
            processState(currentState, n);
        }

        for (int currentState = finalState; currentState >= 1; currentState--) {
            processState(currentState, n);
        }

        int maxState = stateTree.keySet().stream().max(Comparator.naturalOrder()).orElse(0);
        used = Stream.generate(() -> 0).limit(maxState + 1).collect(Collectors.toList());
        height = Stream.generate(() -> 0).limit(maxState + 1).collect(Collectors.toList());
        newParents = Stream.generate(() -> 0).limit(maxState + 1).collect(Collectors.toList());

        dfs(1, -1, 0, new ArrayList<>());
//        List<Integer> seq = buildSeq();

        System.out.println(arr.size() - 1);
        for (int i = 1; i < arr.size(); i++) {
            int prevState = arr.get(i - 1);
            int nowState = arr.get(i);
            for (int j = 0; j < n; j++) {
                int maskedPrev = prevState & (1 << j);
                int maskedNow = nowState & (1 << j);
                if (maskedPrev != maskedNow) {
                    System.out.printf("%d ", j + 1);
                }
            }
        }
    }
}
