﻿#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

const int mod = 1e9 + 7;
vector <int> primes = { 2,3,5,7 };
map <int64_t, int64_t> big_primes;
vector <int64_t> winx;

void Next() {
    int cur = primes.back() + 2;
    while (true) {
        bool flag = true;
        for (int i = 0; primes[i] * primes[i] <= cur; ++i) {
            if (cur % primes[i] == 0) {
                flag = false;
                break;
            }
        }
        if (flag == true) {
            break;
        }
        else {
            cur += 2;
        }
    }
    primes.push_back(cur);
}

void InitPrimes() {
    while (primes.back() < 32000) {
        Next();
    }
    winx.resize(primes.size());
}


int64_t a, b, c;
int64_t Calc(int64_t i) {
    return a * i * i + b * i + c;
}

void AddToFactorize(int64_t num) {
    for (int i = 0; i < primes.size(); ++i) {
        while (num % primes[i] == 0) {
            ++winx[i];
            num /= primes[i];
        }
        if (num == 1) {
            break;
        }
    }
    if (num > 1) {
        big_primes[num]++;
    }
}


int main() {
    InitPrimes();
    int  n;

    cin >> a >> b >> c >> n;

    for (int i = 0; i < n; ++i) {
        int64_t current = Calc(i);
        AddToFactorize(current);
    }
    int64_t ans = 1;

    for (int i = 0; i < winx.size(); ++i) {
        if (winx[i] % 2 == 1) {
            --winx[i];
        }
        for (int j = 0; j < winx[i]; ++j) {
            ans *= primes[i];
            ans %= mod;
        }
    }
    for (auto e : big_primes) {
        if (e.second % 2 == 1) {
            --e.second;
        }
        for (int j = 0; j < e.second; ++j) {
            ans *= e.first;
            ans %= mod;
        }
    }
    cout << ans << endl;

    return 0;
}