#include <cmath>

#include <iostream>
#include <stdint.h>
  
using namespace std;
  
typedef long long ll;
#define speed ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

__int128_t gcd(__int128_t a,__int128_t b,__int128_t &x,__int128_t &y) {
    if (a==0) {
        x = 0;y = 1;
        return b;
    }
    __int128_t x1, y1;
    __int128_t g = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return g;
}

void shift_solution (__int128_t & x, __int128_t & y, __int128_t a, __int128_t b, __int128_t cnt) {
    x += cnt * b;
    y -= cnt * a;
     
}

bool find_any_solution (__int128_t a, __int128_t b, __int128_t c, __int128_t & x0, __int128_t & y0, __int128_t & g) {
    g = gcd (abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0)   x0 *= -1;
    if (b < 0)   y0 *= -1;
    return true;
}

ll find_all_solutions(__int128_t a, __int128_t b, __int128_t c, __int128_t minx, __int128_t maxx, __int128_t miny, __int128_t maxy) {
    __int128_t x, y, g;
    if (!find_any_solution(a, b, c, x, y, g))
        return 0;
    a /= g;  b /= g;
  
    __int128_t sign_a = a>0 ? +1 : -1;
    __int128_t sign_b = b>0 ? +1 : -1;
  
    shift_solution (x, y, a, b, (minx - x) / b);
    if (x < minx)
        shift_solution (x, y, a, b, sign_b);
    if (x > maxx)
        return 0;
    __int128_t lx1 = x;
  
    shift_solution (x, y, a, b, (maxx - x) / b);
    if (x > maxx)
        shift_solution (x, y, a, b, -sign_b);
    __int128_t rx1 = x;
  
    shift_solution (x, y, a, b, - (miny - y) / a);
    if (y < miny)
        shift_solution (x, y, a, b, -sign_a);
    if (y > maxy)
        return 0;
    __int128_t lx2 = x;
  
    shift_solution (x, y, a, b, - (maxy - y) / a);
    if (y > maxy)
        shift_solution (x, y, a, b, sign_a);
    __int128_t rx2 = x;
  
    if (lx2 > rx2)
        swap (lx2, rx2);
    __int128_t lx = max (lx1, lx2);
    __int128_t rx = min (rx1, rx2);
  
    return (rx - lx) / abs(b) + 1;
}
void solve() {
    __int128_t b, d;
    cin >> b >> d;

    cout << find_all_solutions(b, d, b * b, 1, b * b, 1, b * b);
}

int main() {
    speed;
    int t = 1;
    cin >> t;
    for(int i = 1; i <= t; i++){
        solve();
    }
}
