#include <cmath>
#include <iostream>
 
using namespace std;
 
typedef long long ll;
#define speed ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
 
ll gcd (ll a, ll b, ll & x, ll & y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd (b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}
 
void shift_solution (ll & x, ll & y, ll a, ll b, ll cnt) {
    // cout << cnt << ' ' << b << ' ' << a << endl;
    // cout << cnt * b << ' ' << cnt * b << endl;
    x += cnt * b;
    y -= cnt * a;
}
  
bool find_any_solution (ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
    g = gcd (abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0)   x0 *= -1;
    if (b < 0)   y0 *= -1;
    return true;
}
 
ll find_all_solutions (ll a, ll b, ll c, ll minx, ll maxx, ll miny, ll maxy) {
    ll x, y, g;
    if (! find_any_solution (a, b, c, x, y, g))
        return 0;
    a /= g;  b /= g;
  
    ll sign_a = a>0 ? +1 : -1;
    ll sign_b = b>0 ? +1 : -1;
  
    shift_solution (x, y, a, b, (minx - x) / b);
    if (x < minx)
        shift_solution (x, y, a, b, sign_b);
    if (x > maxx)
        return 0;
    ll lx1 = x;
  
    shift_solution (x, y, a, b, (maxx - x) / b);
    if (x > maxx)
        shift_solution (x, y, a, b, -sign_b);
    ll rx1 = x;
  
    shift_solution (x, y, a, b, - (miny - y) / a);
    if (y < miny)
        shift_solution (x, y, a, b, -sign_a);
    if (y > maxy)
        return 0;
    ll lx2 = x;
  
    shift_solution (x, y, a, b, - (maxy - y) / a);
    if (y > maxy)
        shift_solution (x, y, a, b, sign_a);
    ll rx2 = x;
  
    if (lx2 > rx2)
        swap (lx2, rx2);
    ll lx = max (lx1, lx2);
    ll rx = min (rx1, rx2);
  
    return (rx - lx) / abs(b) + 1;
}
 
void solve() {
    // a = b
    // c = d
    // b = d
 
    // p1 = a / b
    // p2 = c / d
    // (p1 + p2) * b = d
    // (a / b + c / d) * d = b
    // ad / b + c = b
    // ad + cb = b^2
    // dx + by = b^2
    // x + 1e9y = 1e18
    // x + 10y = 100
    // x + y = 1
    ll b, d;
    cin >> b >> d;
    ll maxX = (b*b - b - 1) / d + 1;
    ll maxY = (b*b - d - 1) / b + 1;
    cout << find_all_solutions(d, b, b * b, 1, maxX, 1, maxY) << endl;
     
}
 
int main() {
    speed;
    int t = 1;
    cin >> t;
    for(int i = 1; i <= t; i++){
        solve();
    }
}