#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>
#include <algorithm>
#include <unordered_set>
#include <cmath>
#include <tuple>

using namespace std;


bool F(int a, int b, vector<tuple<int, int, int>>& nodes) {
    if (a + b == 0) {
        return true;
    }

    int root_weight = 2;
    if (b > 0) {
        b--;
    } else {
        root_weight = 1;
        a--;
    }

    int a1 = 0, b1 = 0, a2 = 0, b2= 0;
    b1 = b / 2;
    b2 = b - b1;
    if (b2 > b1) {
        a1 += min(2, a);
        a -= a1;
    }

    a2 = a - (a / 2);
    a1 += (a / 2);

    if (abs(a1 + 2 * b1 - a2 - 2 * b2) > 1) {
        return false;
    }
    int left_index = a1 + b1 > 0 ? nodes.size() + 2 : 0;
    int right_index = a2 + b2 > 0 ? nodes.size() + 2 + a1 + b1 : 0;

    auto tuple = make_tuple(root_weight, left_index, right_index);
    nodes.push_back(tuple);

    if (!F(a1, b1, nodes)) {
        return false;
    }

    if (!F(a2, b2, nodes)) {
        return false;
    }

    return true;
}

void solve() {
    int a, b;
    cin >> a >> b;
    vector<tuple<int, int, int>> nodes;
    if (F(a, b, nodes)) {
        for (size_t i = 0; i < a + b; i++)
        {
            cout << get<0>(nodes[i]) << " " << get<1>(nodes[i]) << " " << get<2>(nodes[i]) << endl;
        }
    } else {
        cout << -1 << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}
