#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

vector<vector<int>> childs;

vector<int> F(vector<int>& roots) {
    if (roots.size() == 0) {
        return vector<int>();
    }
    if (roots.size() == 1) {
        vector<int> res{roots[0]};
        for (int r : F(childs[roots[0]])) {
            res.push_back(r);
        }
        return res;
    }
    vector<int> newRoots;
    for (int i = 1; i < roots.size();i++) {
        newRoots.push_back(roots[i]);
    }
    auto ops = F(vector<int>{roots[0]});
    auto other_ops = F(newRoots);
    vector<int> reversed;
    for (int i = 0; i < other_ops.size(); i++)
        reversed.push_back(other_ops[i]);
    std::reverse(reversed.begin(),reversed.end());
    bool current_rev = true;
    vector<int> result;
    result.insert(result.end(), other_ops.begin(), other_ops.end() );
    
    for (auto op : ops) {
        result.push_back(op);
        if (current_rev) {
            result.insert(result.end(), reversed.begin(), reversed.end() );
            current_rev = false;
        } else {
            result.insert(result.end(), other_ops.begin(), other_ops.end() );
            current_rev = true;
        }
    }
    
    return result;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        childs.push_back(vector<int>());
    }
    for (int i = 0; i < n-1; i++) {
        int parent;
        cin >> parent;
        childs[parent-1].push_back(i+1);
    }
    vector<int> result = F(childs[0]);
    
    std::cout << result.size() << endl;
    for (int i = 0; i < result.size(); i++) {
        cout << result[i]+1 << " ";
    }
    cout << endl;
}