#include <iostream>

using namespace std;

struct Node {
    int left, right, weight;
};

Node tree[(int)4e5];

int weight(int root) {
    auto cur = &tree[root];
    if (cur->weight == 0) {
        return 0;
    }

    auto sum = cur->weight;
    if (cur->left != 0) {
        sum += weight(cur->left);
    }
    if (cur->right != 0) {
        sum += weight(cur->right);
    }

    return sum;
}

int balance(int root) {
    auto cur = tree[root];
    auto left_weight = cur.left == 0 ? 0 : weight(cur.left);
    auto right_weight = cur.right == 0 ? 0 : weight(cur.right);

    if (left_weight > right_weight) {
        return 1;
    }

    if (left_weight == right_weight) {
        return 0;
    }

    return -1;
}

bool add(int root, int& a, int& b) {
    auto cur = &tree[root];

    if (cur->weight == 0) {
        cur->weight = 1;
        a--;
        return true;
    }

    auto res = balance(root);

    if (res == 1) {
        cur->right = 2 * root + 2;
        auto right = &tree[cur->right];
        if (right->weight == 0) {
            if (b > 0) {
                right->weight = 2;
                b--;
            } else if (a > 0) {
                right->weight = 1;
                a--;
            }
            return true;
        }
        return add(cur->right, a, b);
    } else if (res == 0) {
        cur->left = 2 * root + 1;
        auto left = &tree[cur->left];
        if (left->weight == 0) {
            if (a > 0) {
                left->weight = 1;
                a--;
            } else if (b > 0) {
                left->weight = 2;
                b--;
            }
            return true;
        }
        return add(cur->left, a, b);
    } else {
        cur->left = 2 * root + 1;
        auto left = &tree[cur->left];
        if (left->weight == 0) {
            if (b > 0) {
                left->weight = 2;
                b--;
            } else if (a > 0) {
                left->weight = 1;
                a--;
            }
            return true;
        }
        return add(cur->left, a, b);
    }
}

void print(int root) {
    auto cur = tree[root];
    if (cur.weight == 0)
        return;

    printf("%d %d %d\n", cur.weight, cur.left, cur.right);

    if (cur.left != 0) {
        print(cur.left);
    }

    if (cur.right != 0) {
        print(cur.right);
    }
}

int main() {
    int a, b;
    cin >> a >> b;

    while ((a > 0 || b > 0) && add (0, a, b)) {}

    for (auto i = 0; i < 4e5;i++) {
        auto cur = tree[i];
        if (cur.weight != 0) {
            printf("%d %d %d\n", cur.weight, cur.left, cur.right);
        }
    }

    return 0;
}
