import kotlin.system.exitProcess

fun main() {
    val (a, b) = readInts()
    val nodes = ArrayList<Node>(a + b)
    build(a, b, nodes)
    for (node in nodes) {
        println("${node.value} ${node.left?.id ?: 0} ${node.right?.id ?: 0}")
    }
}

fun build(a: Int, b: Int, nodes: MutableList<Node>): Node? {
    when {
        a == 0 && b == 0 -> return null
        b % 2 == 0 && a > 0 -> {
            val node = Node(nodes.size + 1, 1)
            nodes.add(node)
            node.left = build((a - 1) / 2, b / 2, nodes)
            node.right = build(a / 2, b / 2, nodes)
            return node
        }
        b % 2 == 1 -> {
            val node = Node(nodes.size + 1, 2)
            nodes.add(node)
            node.left = build(a / 2, b / 2, nodes)
            node.right = build((a + 1) / 2, b / 2, nodes)
            return node
        }
        else -> {
            println(-1)
            exitProcess(0)
        }
    }
}

data class Node(val id: Int, val value: Int, var left: Node? = null, var right: Node? = null)

/**
 * IO functions
 */
private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLong() = readLn().toLong()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
private fun readLongs() = readStrings().map { it.toLong() }
private fun readDoubles() = readStrings().map { it.toDouble() }