﻿#include <algorithm>
#include <assert.h>
#include <chrono>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ll MOD = 1000000007;
const ld EPS = 1e-11;
const ll INFL = 1e18;
const ll INF = 1e9 + 7;
const ld PI = acos(-1);

mt19937 rnd((unsigned)chrono::steady_clock::now().time_since_epoch().count());

int dfs(int ci, int ch, int c1, int b, vector<int>& w, vector<int>& l, vector<int>& r) {
    //cout << ci << " " << ch << " " << c1 << "\n";
    if ((b >> ch) % 2 == 1) {
        w[ci] = 2;
    }
    else if (c1 > 0) {
        w[ci] = 1;
        --c1;
    }
    if (w[ci] == 0) {
        return 0;
    }
    
    l[ci] = ci + 2;
    int lastl = dfs(ci + 1, ch + 1, (c1 + 1) / 2, b, w, l, r);
    if (lastl == 0) {
        l[ci] = 0;
        return ci;
    }
    r[ci] = lastl + 2;
    int lastr = dfs(lastl + 1, ch + 1, c1 / 2, b, w, l, r);
    if (lastr == 0) {
        r[ci] = 0;
        return lastl;
    }
    return lastr;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int a, b;
    cin >> a >> b;

    int need1 = 0;
    for (int i = 0; i < 30; ++i) {
        if ((b >> i) == 0) {
            break;
        }
        if ((b >> i) % 2 == 0) {
            need1 += (1 << i);
        }
    }

    if (need1 > a) {
        cout << "-1\n";
        return 0;
    }

    int n = a + b;

    vector<int> w(n * 2, 0), l(n, 0), r(n, 0);

    dfs(0, 0, a, b, w, l, r);

    for (int i = 0; i < n; ++i) {
        cout << w[i] << " " << l[i] << " " << r[i] << "\n";
    }

    return 0;
}