#pragma GCC optimize("O3")

#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define rep(i, a, n) for (int i = (a); i < (n); ++i)
#define per(i, a, n) for (int i = (n)-1; i >= (a); --i)

template <typename T1, typename T2>
inline bool umin(T1& x, const T2& y) { return y < x ? x = y, true : false; }

template <typename T1, typename T2>
inline bool umax(T1& x, const T2& y) { return x < y ? x = y, true : false; }

typedef long long ll;

const int maxn = (int)50+5;
const int mod = (int)1e9+7;
const int inf = (int)1e9+17;
const ll llinf = (ll)1e18+17;

const int dx[] = {1, 0, -1, -1, 0, 1};
const int dy[] = {0, 1, 1, 0, -1, -1};


int n;
bool win;
int sx, sy, tx, ty;
std::function<void(void)> strategy;
bool f[maxn + maxn][maxn + maxn];


bool& cell(int x, int y) {
  return f[x + maxn][y + maxn];
}

void make_move(int x, int y) {
  cout << x << ' ' << y << endl;
  sx += x;
  sy += y;
  assert(cell(sx, sy) == false);
  cell(sx, sy) = true;
}

void update_game_state() {
  string status;
  cin >> status;
  if (status == "win") {
    win = true;
  } else {
    assert(status == "move");
    int x, y;
    cin >> x >> y;
    tx += x, ty += y;
    cell(tx, ty) = true;
  }
}

bool can_move(int x, int y) {
  if (x < -n || x > n) return false;
  int l = -n, r = n;
  if (x < 0) l -= x;
  else r -= x;
  if (y < l || r < y) return false;
  return !cell(x, y);
}

namespace circle_strategy {
  vector<int> order;
  int ptr = 0;
  bool once = false;
  void reset() { once = false, ptr = 0; }
  void do_move() {
    for (int it = 0; it < 5; ++it) {
      int nx = sx + dx[order[ptr]];
      int ny = sy + dy[order[ptr]];
      if (nx == -n && ny == 0 && !once) {
        ptr = (ptr + 1) % 4;
        once = true;
      }
      if (can_move(sx + dx[order[ptr]], sy + dy[order[ptr]])) {
        make_move(dx[order[ptr]], dy[order[ptr]]);
        return;
      }
      ptr = (ptr+1) % 4;
    }
    // make_move(0, 0);
    assert(false);
  }
}

namespace third_strategy {

int dir = -1;

void reset() { dir = -1; }

void do_move() {
  if (sx < 0) {
    make_move(1, 0);
  } else {
    if (dir == -1) {
      if (ty > 0) {
        dir = 5;
      } else {
        dir = 1;
      }
    }
    if (!can_move(sx + dx[dir], sy + dy[dir])) {
      strategy = circle_strategy::do_move;
      if (dir == 5) {
        if (rand() % 2 == 0) circle_strategy::order = {3, 2, 0, 5};
        else circle_strategy::order = {2, 3, 5, 0};
      } else {
        if (rand() % 2 == 0) circle_strategy::order = {3, 4, 0, 1};
        else circle_strategy::order = {4, 3, 1, 0};
      }
      strategy();
      return;
    }
    make_move(dx[dir], dy[dir]);
  }
}

}

void reset() {
  third_strategy::reset();
  circle_strategy::reset();

  rep(i, -n, n+1) rep(j, -n, n+1) {
    cell(i, j) = false;
  }
  sx = -n / 2, sy = 0;
  tx = n / 2, ty = 0;
  cell(sx, sy) = true;
  cell(tx, ty) = true;
  
  strategy = third_strategy::do_move;
  win = false;
}

void solve() {
  reset();
  while (!win) {
    strategy();
    update_game_state();
  }
}

int32_t main() {
  // ios_base::sync_with_stdio(false);
  // cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
  // freopen("input.txt", "r", stdin);
  // freopen("brainteaser2.in", "r", stdin);
  // freopen("output.txt", "w", stdout);
#endif

  srand(55);
  int t;
  cin >> t >> n;
  while (t --> 0) {
    solve();
  }

  return 0;
}
