#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 30;
const int inf = 1e9;

string a[maxn];
vector<int> edge[maxn];

vector<pair<int, int>> delta;
vector<int> dx = {1, 0, -1, -1, 0, 1};
vector<int> dy = {0, 1, 1, 0, -1, -1};

int used[2 * maxn][2 * maxn];
int n = 20;
int ans = 0;

void Dfs(int x, int y) {
    used[x + maxn][y + maxn] = true;
    ++ans;
    random_shuffle(delta.begin(), delta.end());
    for (int i = 0; i < 6; ++i) {
        int new_x = x + delta[i].first;
        int new_y = y + delta[i].second;
        if (new_x < -n || new_x > n) {
            continue;
        }
        if (new_y < -n || new_y > n) {
            continue;
        }
        if (new_x + new_y > n || new_x + new_y < -n) {
            continue;
        }
        if (!used[maxn + new_x][maxn + new_y]) {
            Dfs(new_x, new_y);
            return;
        }
    }
}

void Solve() {
    int n;
    cin >> n;
    string res;
    for (int j = 0; j < 2 * maxn; ++j) {
        for (int k = 0; k < 2 * maxn; ++k) {
            used[j][k] = 0;
        }
    }

    int my_x = -n / 2, my_y = 0;
    int en_x = n / 2, en_y = 0;

    used[my_x + maxn][my_y + maxn] = true;
    used[en_x + maxn][en_y + maxn] = true;

    for (int i = 0; i < n; ++i) {
        cout << "0 1" << endl;
        ++my_y;
        used[my_x + maxn][my_y + maxn] = true;

        
        cin >> res;
        if (res != "move") {
            return;
        }
        if (res == "move") {
            int x, y;
            cin >> x >> y;
            en_x += x;
            en_y += y;
            used[en_x + maxn][en_y + maxn] = true;
        }
    }

    while (true) {
        cout << "-1 0" << endl;
        --my_x;
        used[my_x + maxn][my_y + maxn] = true;
        
        cin >> res;
        if (res != "move") {
            return;
        }
        if (res == "move") {
            int x, y;
            cin >> x >> y;
            en_x += x;
            en_y += y;
            used[en_x + maxn][en_y + maxn] = true;
        }


        for (int i = 0; i < n; ++i) {
            cout << "0 -1" << endl;
            --my_x;
            used[my_x + maxn][my_y + maxn] = true;
            
            cin >> res;
            if (res != "move") {
                return;
            }
            if (res == "move") {
                int x, y;
                cin >> x >> y;
                en_x += x;
                en_y += y;
                used[en_x + maxn][en_y + maxn] = true;
            }
        }

        for (int i = 0; i < n; ++i) {
            cout << "1 -1" << endl;
            --my_x;
            used[my_x + maxn][my_y + maxn] = true;
            
            cin >> res;
            if (res != "move") {
                return;
            }
            if (res == "move") {
                int x, y;
                cin >> x >> y;
                en_x += x;
                en_y += y;
                used[en_x + maxn][en_y + maxn] = true;
            }
        }




        cout << "-1 0" << endl;
        --my_x;
        used[my_x + maxn][my_y + maxn] = true;
        
        cin >> res;
        if (res != "move") {
            return;
        }
        if (res == "move") {
            int x, y;
            cin >> x >> y;
            en_x += x;
            en_y += y;
            used[en_x + maxn][en_y + maxn] = true;
        }




        for (int i = 0; i < n; ++i) {
            cout << "-1 1" << endl;
            --my_x;
            used[my_x + maxn][my_y + maxn] = true;
            
            cin >> res;
            if (res != "move") {
                return;
            }
            if (res == "move") {
                int x, y;
                cin >> x >> y;
                en_x += x;
                en_y += y;
                used[en_x + maxn][en_y + maxn] = true;
            }
        }

        for (int i = 0; i < n; ++i) {
            cout << "0 1" << endl;
            --my_x;
            used[my_x + maxn][my_y + maxn] = true;
            
            cin >> res;
            if (res != "move") {
                return;
            }
            if (res == "move") {
                int x, y;
                cin >> x >> y;
                en_x += x;
                en_y += y;
                used[en_x + maxn][en_y + maxn] = true;
            }
        }

    }
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    // freopen("dome.in", "r", stdin);
    // freopen("dome.out", "w", stdout);
    // ios_base::sync_with_stdio(false);

    int q;
    cin >> q;
    while (q--) {
        Solve();
    }
    
    // int n = 20;
    // // used[maxn + n / 2][maxn] = true;
    // for (int i = 0; i < 6; ++i) {
    //     delta.push_back({dx[i], dy[i]});
    // }
    // int res = 0;
    // for (int i = 0; i < 10000; ++i) {
    //     for (int j = 0; j < 2 * maxn; ++j) {
    //         for (int k = 0; k < 2 * maxn; ++k) {
    //             used[j][k] = 0;
    //         }
    //     }
    //     ans = 0;
    //     Dfs(n / 2, 0);
    //     res = max(res, ans);
    //     // cout << ans << endl;
    // }
    // cout << res << endl;
}