#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>

using namespace std;

int64_t gcd(int64_t a, int64_t b, int64_t& x, int64_t& y) {
  if (b == 0) {
    x = 1;
    y = 0;
    return a;
  }
  int64_t x1, y1;
  int64_t d = gcd(b, a % b, x1, y1);
  x = y1;
  y = x1 - y1 * (a / b);
  return d;
}

bool find_any_solution(int64_t a, int64_t b, int64_t c, int64_t& x0, int64_t& y0, int64_t& g) {
  g = gcd(abs(a), abs(b), x0, y0);
  if (c % g) {
    return false;
  }

  x0 *= c / g;
  y0 *= c / g;
  if (a < 0) x0 = -x0;
  if (b < 0) y0 = -y0;
  return true;
}

void shift_solution(int64_t& x, int64_t& y, int64_t a, int64_t b, int64_t cnt) {
  x += cnt * b;
  y -= cnt * a;
}

int64_t find_all_solutions(int64_t a, int64_t b, int64_t c, int64_t minx, int64_t maxx, int64_t miny, int64_t maxy) {
  int64_t x, y, g;
  if (!find_any_solution(a, b, c, x, y, g))
    return 0;
  a /= g;
  b /= g;

  int64_t sign_a = a > 0 ? +1 : -1;
  int64_t sign_b = b > 0 ? +1 : -1;

  shift_solution(x, y, a, b, (minx - x) / b);
  if (x < minx)
    shift_solution(x, y, a, b, sign_b);
  if (x > maxx)
    return 0;
  int64_t lx1 = x;

  shift_solution(x, y, a, b, (maxx - x) / b);
  if (x > maxx)
    shift_solution(x, y, a, b, -sign_b);
  int64_t rx1 = x;

  shift_solution(x, y, a, b, -(miny - y) / a);
  if (y < miny)
    shift_solution(x, y, a, b, -sign_a);
  if (y > maxy)
    return 0;
  int64_t lx2 = x;

  shift_solution(x, y, a, b, -(maxy - y) / a);
  if (y > maxy)
    shift_solution(x, y, a, b, sign_a);
  int64_t rx2 = x;

  if (lx2 > rx2)
    swap(lx2, rx2);
  int64_t lx = max(lx1, lx2);
  int64_t rx = min(rx1, rx2);

  if (lx > rx)
    return 0;
  return (rx - lx) / abs(b) + 1;
}

int64_t Solve(int64_t b, int64_t d) {
  int64_t ans = 0;
  for (int c = 1; c <= 10000; ++c) {
    int a = (b - c) * b;
    if (a % d == 0) {
      a /= d;
      if (a >= 1) {
        ans += 1;
      }
    }
  }
  return ans;
}

int main() {
  int64_t n;
  cin >> n;
  while (n--) {
    int64_t b, d;
    cin >> b >> d;
//  bool flag = false;
//  for (int b = 1; b <= 1000; ++b) {
//    for (int d = 1; d <= 1000; ++d) {
    auto ans = find_all_solutions(d, b, b * b, 1, 1e18 + 111, 1, 1e18 + 111);
//      if (ans != Solve(b, d)) {
//        cout << b << " " << d << " " << ans << " " << Solve(b, d) << "\n";
////        flag = true;
////        break;
//      }
//    }
//    if (flag) {
//      break;
//    }
    cout << ans << "\n";
  }
//  }

  return 0;
}