#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp> // Общий файл.
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

ll BinPow(ll a, ll b, ll mod) {
    ll result = 1;

    while (b) {
        if (b & 1) {
            result *= a;
            result %= mod;
        }

        a *= a;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll MulMod(ll a, ll b, ll mod) {
    ll result = 0;

    while (b) {
        if (b & 1) {
            result += a;
            result %= mod;
        }

        a *= 2;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll RevElement(ll a, ll mod) {
    return BinPow(a, mod - 2, mod);
}

ll calc(ll x, ll y) {
    return -x * y;
}

ll nextInt() {
    char c = getchar();
    ll res = 0;

    do {
        res *= 10;
        res += c - '0';
        c = getchar();
    } while (c >= '0' && c <= '9');

    return res;
}

const int INF = 1e9;
const int MAX_N = 200000;

int mn[MAX_N], mx[MAX_N], key[MAX_N], anc[20][MAX_N], l_son[MAX_N], r_son[MAX_N], height[MAX_N], tin[MAX_N], tout[MAX_N];
int timer;

void dfs(int v, int p) {
    mn[v] = key[v];
    mx[v] = key[v];

    height[v] = height[p] + 1;
    anc[0][v] = p;

    for (int i = 1; i < 20; ++i) {
        anc[i][v] = anc[i - 1][anc[i - 1][v]];
    }

    tin[v] = timer++;

    if (l_son[v] != -1) {
        dfs(l_son[v], v);
        mn[v] = min(mn[l_son[v]], mn[v]);
    }

    if (r_son[v] != -1) {
        dfs(r_son[v], v);
        mx[v] = max(mx[r_son[v]], mx[v]);
    }

    tout[v] = timer++;
}

bool is_mixed(int v, int l, int r) {
    return (mn[v] < l || mx[v] > r) && mn[v] <= r && mx[v] >= l;
}

bool is_upper(int v, int u) {
    return tin[v] < tin[u] && tout[v] > tout[u];
}

int upper_mixed(int v, int l, int r) {
    if (is_mixed(v, l, r)) {
        return v;
    }

    for (int i = 19; i >= 0; --i) {
        if (!is_mixed(anc[i][v], l, r)) {
            v = anc[i][v];
        }
    }

    return anc[0][v];
}

int lca(int v, int u) {
    if (v == u) {
        return v;
    }

    if (is_upper(v, u)) {
        return v;
    }

    if (is_upper(u, v)) {
        return u;
    }

    for (int i = 19; i >= 0; --i) {
        if (!is_upper(anc[i][v], u)) {
            v = anc[i][v];
        }
    }

    return anc[0][v];
}

void Solve() {
    int n, q;
    cin >> n;
    vector<pair<int, int> > values;

    for (int i = 0; i < n; ++i) {
        cin >> l_son[i] >> r_son[i] >> key[i];
        l_son[i]--;
        r_son[i]--;
        values.emplace_back(key[i], i);
    }

    sort(begin(values), end(values));
    dfs(0, 0);

    cin >> q;

    while (q--) {
        int l, r;
        cin >> l >> r;

        if (!is_mixed(0, l, r)) {
            cout << "1\n";
            continue;
        }


        int lb = lower_bound(begin(values), end(values), make_pair(l, -INF))->second,
                rb = (--upper_bound(begin(values), end(values), make_pair(r, INF)))->second;

//        if (key[lb] >= key[rb]) {
//            cout << "3\n";
//            continue;
//        }

        int lm = upper_mixed(lb, l, r), rm = upper_mixed(rb, l, r);
        int res = 0;

        int mm = lca(lm, rm);
        res = height[lm] + height[rm] - height[mm];

        cout << res * 2 + 1 << "\n";
    }
}

int main() {
    //    freopen("flow.in", "r", stdin);
    //    freopen("flow.out", "w", stdout);
    //freopen("../in", "r", stdin);
    //freopen("../out.txt", "w", stdout);
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    Solve();
    return 0;
}