#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef double DB;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef tuple<int, int, int> tint;
typedef tuple<ll, ll, ll> tll;
typedef long double LDB;

#define int ll
#define input(f)\
            freopen(f, "r", stdin)
#define output(f)\
            freopen(f, "w", stdout)
#define space " "
#define mp make_pair
#define pb push_back
#define pf push_front
#define ff first
#define ss second
#define ALL(x) x.begin(), x.end()
#define rALL(x) x.rbegin(), x.rend()
#define forr(i, n) for(int i = 0; i < (n); i++)
#define bits(x) __builtin_popcount(x)
#define bitsll(x) __builtin_popcountll(x)

template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
    os << '{';
    string sep;
    for (const auto& x : v) os << sep << x, sep = ", ";
    return os << '}';
}

template <typename T, size_t size>
ostream& operator<<(ostream& os, const array<T, size>& arr) {
    os << '{';
    string sep;
    for (const auto& x : arr) os << sep << x, sep = ", ";
    return os << '}';
}

template <typename A, typename B>
ostream& operator<<(ostream& os, const pair<A, B>& p) { return os << '(' << p.first << ", " << p.second << ')'; }

template<class T>
T bin_pow(T base, T p) {
    if (p == 1) {
        return base;
    }
    if (base == 1 || p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        ll tmp = binpow(base, p / 2);
        return tmp * tmp;
    } else {
        return binpow(base, p - 1) * base;
    }
}

template<class T>
T bin_pow(T base, T p, T MOD) {
    if (p == 1) {
        return base;
    }
    if (base == 1 || p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        ll tmp = binpow(base, p / 2);
        return (tmp * tmp) % MOD;
    } else {
        return (binpow(base, p - 1) * base) % MOD;
    }
}

template<class T>
T sqr(T x) { return x * x; }

template<class T>
T lcm(T a, T b) { return a / __gcd(a, b) * b; }

template<class T>
double eu_dist(pair<T, T> a, pair<T, T> b) {
    return sqrt(sqr(a.first - b.first) + sqr(a.second - b.second));
}

template<class T>
bool isSquare(T x) {
    T y = sqrt(x + 0.5);
    return (y * y) == x;
}

template<class T1, class T2>
T1 eqMin(T1 &x, const T2 &y) {
    if (T1(y) < x) return x = y;
    return x;
}

template<class T1, class T2>
T1 eqMax(T1 &x, const T2 &y) {
    if (T1(y) > x) return x = y;
    return x;
}

template<typename T>
int sign(T val) {
    return (T(0) < val) - (val < T(0));
}

template<typename T>
T get_bit(T mask, int idx) {
    return mask & (T(1) << (idx));
}

template<typename T>
T set_bit(T mask, int idx, int val) {
    if (val == 0) {
        mask -= T(get_bit(mask, idx)) << (idx);
    } else {
        mask |= (T(1) << (idx));
    }
    return mask;
}


const double PI = acos(-1);
const double EPS = 1e-8;
const int INF = (int) 2e9;
const ll LINF = (ull) 1e18 + 5;
const ll MOD = (ll) 1e9 + 7;
const int N = (int) 2e5 + 10;

template<class T>
struct SCG {
public:
    vector<vector<T>> G;
    vector<vector<int>> comps;
    vector<int> comp_ptr;
    int size = 0;

    SCG(vector<T> *graph, size_t sz) {
        vector<int> order;
        vector<int> used(sz);
        vector<vector<T>> GT(sz, vector<T>());
        comp_ptr = vector<int>(sz, 0);
        comps = vector<vector<int>>();

        auto make_GT = [&]() {
            for (int i = 0; i < sz; i++) {
                for (auto to : graph[i]) {
                    GT[to].push_back(i);
                }
            }
        };

        make_GT();

        auto dfs1 = [&](auto dfs1, int v) -> void {
            used[v] = 1;
            for (auto to : graph[v]) {
                if (!used[to]) {
                    dfs1(dfs1, to);
                }
            }
            order.push_back(v);
        };

        for (int i = 0; i < sz; i++) {
            if (!used[i]) {
                dfs1(dfs1, i);
            }
        }

        auto dfs2 = [&](auto dfs2, int v, int comp) -> void {
            used[v] = 1;
            comp_ptr[v] = comp;
            if (comp >= comps.size()) {
               comps.push_back(vector<T>());
            }
            comps[comp].push_back(v);
            for (auto to : GT[v]) {
                if (!used[to]) {
                    dfs2(dfs2, to, comp);
                }
            }
        };

        fill(ALL(used), 0);
        size = 0;
        reverse(ALL(order));
        for (int i = 0; i < sz; i++) {
            int v = order[i];
            if (!used[v]) {
                dfs2(dfs2, v, size++);
            }
        }
        size--;

        G = vector<vector<T>>(size, vector<T>());
        for (int i = 0; i < sz; i++) {
            for (auto to : graph[i]) {
                if (comp_ptr[to] != comp_ptr[i]) {
                    G[comp_ptr[i]].push_back(comp_ptr[to]);
                }
            }
        }

//        for (int i = 0; i < size; i++) {
//            sort(ALL(G[i]));
//            G[i].erase(unique(ALL(G[i])), G[i].end());
//        }
    }

    vector<T> &operator[](size_t idx) { return G[idx]; }
};

int gcd (int a, int b, int & x, int & y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    int x1, y1;
    int d = gcd (b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_any_solution (int a, int b, int c, int & x0, int & y0, int & g) {
    g = gcd (abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0)   x0 *= -1;
    if (b < 0)   y0 *= -1;
    return true;
}

void shift_solution (int & x, int & y, int a, int b, int cnt) {
    x += cnt * b;
    y -= cnt * a;
}

int find_all_solutions (int a, int b, int c, int minx, int maxx, int miny, int maxy) {
    int x, y, g;
    if (! find_any_solution (a, b, c, x, y, g))
        return 0;
    a /= g;  b /= g;

    int sign_a = a>0 ? +1 : -1;
    int sign_b = b>0 ? +1 : -1;

    shift_solution (x, y, a, b, (minx - x) / b);
    if (x < minx)
        shift_solution (x, y, a, b, sign_b);
    if (x > maxx)
        return 0;
    int lx1 = x;

    shift_solution (x, y, a, b, (maxx - x) / b);
    if (x > maxx)
        shift_solution (x, y, a, b, -sign_b);
    int rx1 = x;

    shift_solution (x, y, a, b, - (miny - y) / a);
    if (y < miny)
        shift_solution (x, y, a, b, -sign_a);
    if (y > maxy)
        return 0;
    int lx2 = x;

    shift_solution (x, y, a, b, - (maxy - y) / a);
    if (y > maxy)
        shift_solution (x, y, a, b, sign_a);
    int rx2 = x;

    if (lx2 > rx2)
        swap (lx2, rx2);
    int lx = max (lx1, lx2);
    int rx = min (rx1, rx2);

    return (rx - lx) / abs(b) + 1;
}

void solve() {
    int b, d;
    cin >> b >> d;

    cout << find_all_solutions(d, b, b * b, 1, LINF, 1, LINF) << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
//    input("sum2.in");
//    output("sum2.out");
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}