#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <stack>
#include <iomanip>
#include <cmath>
#include <functional>
#include <random>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <chrono>
#include <climits>
//#include <ext/rope>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;
//using namespace __gnu_cxx;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long ll;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<ll, ll> pll;
typedef double ld;
typedef vector<bool> vb;

const int MAXN = 200010;
const int INF = 2e9;
const ll INFLL = 4e18;

vector <vector<int>> ch(21);
vector <int> par(21);
map<unsigned long, int> masks;
vector<int> depth(21);
int n;

bool comp(int a, int b) {
    return depth[a] < depth[b];
}

bool comp2(pair<bitset<20>,int> a, pair<bitset<20>,int>  b) {
    return depth[a.se] < depth[b.se];
}

int calc_depth(int v) {
    if (ch[v].empty()) {
        depth[v] = 1;
        return 1;
    }
    int d = 0;
    for (auto i : ch[v]) {
        d += calc_depth(i);
    }
    depth[v] = d + 1;
    return d + 1;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;

    cin >> n;
    par[0] = -1;
    bitset<20> mask = 0;
    mask[0] = true;
    forn(i, n - 1) {
        int k;
        cin >> k;
        ch[k - 1].push_back(i + 1);
        par[i + 1] = k - 1;
    }

    calc_depth(0);

    forn(i, n) {
        //cout << depth[i] << " ";
        sort(all(ch[i]), comp);
    }

    vector<vector<pair<bitset<20>, int>>> downs (1100000);
    vector<vector<pair<bitset<20>, int>>> ups (1100000);
    forn(tt, 11000000) {
        if (mask[n]) break;
        for (int i = 0; i < n; ++i) {
            if (!mask[i]) continue;
            for (int j = 0; j < ch[i].size(); ++j) {
                bitset<20> new_mask = mask;
                new_mask[ch[i][j]] = true;
                downs[mask.to_ulong()].push_back(mp(new_mask.to_ulong(), ch[i][j]));
            }
            if (par[i] < 0) continue;
            bool is_tail = true;
            for (int j = 0; j < ch[i].size(); ++j) {
                if (mask[ch[i][j]]) {
                    is_tail = false;
                    break;
                }
            }
            if (!is_tail) continue;
            bitset<20> new_mask = mask;
            new_mask[i] = false;
            ups[mask.to_ulong()].push_back(mp(new_mask.to_ulong(), i));
        }
        sort(all(ups[mask.to_ulong()]), comp2);
        mask = bitset<20> (mask.to_ulong() + 1);
    }

    mask = bitset<20>(0);
    mask[0] = true;
    vector <bool> used(1100000, false);
    used[mask.to_ulong()] = true;

    int len = 0;
    vi path;
    while (true) {
        bool go = false;
        for (int i = 0; i < ups[mask.to_ulong()].size(); ++i) {
            if (used[ups[mask.to_ulong()][i].fi.to_ulong()]) continue;
            len++;
            path.pb(ups[mask.to_ulong()][i].se);
            mask = ups[mask.to_ulong()][i].fi;
            go = true;
            used[mask.to_ulong()] = true;
            break;
        }
        if (go) continue;
        for (int i = 0; i < downs[mask.to_ulong()].size(); ++i) {
            if (used[downs[mask.to_ulong()][i].fi.to_ulong()]) continue;
            len++;
            path.pb(downs[mask.to_ulong()][i].se);
            mask = downs[mask.to_ulong()][i].fi;
            go = true;
            used[mask.to_ulong()] = true;
            break;
        }
        if (!go) break;
    }
    cout << len << "\n";
    for (auto i : path) {
        cout << i + 1 << " ";
    }
}