#include <bits/stdc++.h>

using namespace std;
#define ll long long

struct TreeNode {
    int val;
    TreeNode *left;
    TreeNode *right;
    int count;
    int minimum;
    int maximum;

    TreeNode() :
    val(0), left(NULL), right(NULL), count(0), maximum(0), minimum(0)
    {}

    void set_mins_and_maxes(TreeNode *root) {
        if (NULL == root) {
            return;
        }

        if ((NULL == root->left) && (NULL == root->right)) {
            root->minimum = root->val;
            root->maximum = root->val;
        }
        
        if (root->left != NULL) {
            set_mins_and_maxes(root->left);
            root->minimum = root->left->minimum;
        }
        else {
            root->minimum = root->val;
        }

        if (root->right != NULL) {
            set_mins_and_maxes(root->right);
            root->maximum = root->right->maximum;
        }
        else {
            root->maximum = root->val;
        }
    }

    void set_counts(TreeNode *root) {
        if (NULL == root) {
            return;
        }

        root->count = 1;
        if (NULL != root->left) {
            set_counts(root->left);
            root->count += root->left->count;
        }
        if (NULL != root->right) {
            set_counts(root->right);
            root->count += root->right->count;
        }
    }

    int lookups(TreeNode *root, int L, int R) {
        if (NULL == root) {
            return 0;
        }
        if (L <= root->minimum && root->maximum <= R) {
            return 0;
        }
        if (root->maximum < L || R < root->minimum) {
            return 0;
        }
        int res = 2;
        if (NULL != root->left) {
            res += lookups(root->left, L, R);
        }
        if (NULL != root->right) {
            res += lookups(root->right, L, R);
        }

        return res;
    }

};

struct direction {
    TreeNode* where;
    bool right;
};

TreeNode* read_node() {
    TreeNode *root = new TreeNode;
    int t;
    cin >> t;
    map<int, direction> put_into;
    int l, r, k;
    cin >> l >> r >> k;
    root->val = k;
    if (l) put_into.insert({l, {root, 0}});
    if (r) put_into.insert({r, {root, 1}});

    for (int i = 2; i <= t; i++) {
        cin >> l >> r >> k;
        auto mapped = put_into.find(i)->second;
        TreeNode *destination;
        if (mapped.right) {
            mapped.where->right = new TreeNode;
            destination = mapped.where->right;
        }
        else {
            mapped.where->left = new TreeNode;
            destination = mapped.where->left;
        }
        destination->val = k;

        if (l) {
            put_into.insert({l, {destination, 0}});
        }
        if (r) {
            put_into.insert({r, {destination, 1}});
        }
    }
    return root;
}

void print_node(TreeNode *root) {
    queue<TreeNode*> q;
    q.push(root);

    while (!q.empty()) {
        queue<TreeNode*> next;
        bool good = 0;

        while (!q.empty()) {
            auto curr = q.front();
            q.pop();
            if (NULL == curr) {
                cout << "NULL ";
                //next.push(NULL);
                //next.push(NULL);

            }

            else {
                good = 1;
                cout << curr->val << " ";
            //if (curr->left) {
                next.push(curr->left);
            //}
            //if (curr->right) {
                next.push(curr->right);
            //}
            }
        }
        if (good) q = next;
        cout << "\n";
    }
}

void find_lookup(TreeNode *root, int L, int R) {
    cout << 1 + root->lookups(root, L, R) << "\n";
}

int main() {
    TreeNode *root = read_node();
    root->set_mins_and_maxes(root);
    root->set_counts(root);

    //print_node(root);

    int repeats  = 0;
    cin >> repeats;
    while (repeats--) {
        int L, R;
        cin >> L >> R;
        find_lookup(root, L, R);
    }
}