import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    static abstract class reader {
        static {
            Locale.setDefault(Locale.US);
        }

        static BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        static StringTokenizer tokenizer;

        static String nextToken() {
            while (tokenizer == null || !tokenizer.hasMoreElements()) {
                try {
                    tokenizer = new StringTokenizer(bufferedReader.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return tokenizer.nextToken();
        }

        static int nextInt() {
            return Integer.parseInt(nextToken());
        }

        static double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        static long nextLong() {
            return Long.parseLong(nextToken());
        }

        static String nextLine() {
            String str = "";
            try {
                str = bufferedReader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }

    static List<Node> list = new ArrayList<>();

    static class Node {
        int id;
        Node left;
        Node right;
        int value;

        public Node(int value) {
            id = list.size();
            this.value = value;
            list.add(this);
        }

        public int getId() {
            return id;
        }

        public int getValue() {
            return value;
        }

        public Node getLeft() {
            return left;
        }

        public void setLeft(Node left) {
            this.left = left;
        }

        public Node getRight() {
            return right;
        }

        public void setRight(Node right) {
            this.right = right;
        }

        public String getString() {
            String s = "";
            s += value;
            s += " ";
            s += left == null ? 0 : (left.getId() + 1);
            s += " ";
            s += right == null ? 0 : (right.getId() + 1);
            return s;
        }
    }

    static Node createNode(int ones, int twos) {
        if (ones == 0 && twos == 0)
            return null;
        if (ones == 0 && twos != 1)
            throw new IllegalArgumentException();
        Node node = new Node(twos % 2 + 1);
        if (twos % 2 == 0) ones--;
        else twos--;
        node.left = createNode(ones / 2 + ones % 2, twos / 2);
        node.right = createNode(ones / 2, twos / 2);
        return node;
    }

    public static void main(String[] args) {
        int ones = reader.nextInt();
        int twos = reader.nextInt();
        try {
            createNode(ones, twos);
            for (Node node : list) {
                System.out.println(node.getString());
            }
        } catch (IllegalArgumentException e) {
            System.out.println(-1);
        }
    }
}