import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    static abstract class reader {
        static {
            Locale.setDefault(Locale.US);
        }

        static BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        static StringTokenizer tokenizer;

        static String nextToken() {
            while (tokenizer == null || !tokenizer.hasMoreElements()) {
                try {
                    tokenizer = new StringTokenizer(bufferedReader.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return tokenizer.nextToken();
        }

        static int nextInt() {
            return Integer.parseInt(nextToken());
        }

        static double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        static long nextLong() {
            return Long.parseLong(nextToken());
        }

        static String nextLine() {
            String str = "";
            try {
                str = bufferedReader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }

    static int common(int a, int b) {
        return 8 - Integer.bitCount(a ^ b);
    }

    public static void main(String[] args) {
        int n = reader.nextInt();
        int[] steps = new int[n];
        boolean[] winner = new boolean[n];
        for (int i = 0; i < n; i++) {
            String s = reader.nextLine();
            for (int j = 0; j < 8; j++) {
                steps[i] <<= 1;
                if (s.charAt(j) == 'W')
                    steps[i] += 1;
            }
        }

        for (int i = n - 2; i >= 0; i--) {
            for (int j = 1; i <= 8 && i + j < n && !winner[i]; j++) {
                int common = common(steps[i], steps[i + j]);
                if (j <= common && !winner[i + j])
                    winner[i] = true;
            }
        }

        for (int i = n-1; i>=0; i--) {
            System.out.print(winner[i] ? 1 : 2);
        }
    }
}