import java.io.*;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    static abstract class reader {
        static {
            Locale.setDefault(Locale.US);
        }

        static BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        static StringTokenizer tokenizer;

        static String nextToken() {
            while (tokenizer == null || !tokenizer.hasMoreElements()) {
                try {
                    tokenizer = new StringTokenizer(bufferedReader.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return tokenizer.nextToken();
        }

        static int nextInt() {
            return Integer.parseInt(nextToken());
        }

        static double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        static long nextLong() {
            return Long.parseLong(nextToken());
        }

        static String nextLine() {
            String str = "";
            try {
                str = bufferedReader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }

    static int common(int a, int b) {
        return 8 - Integer.bitCount(a ^ b);
    }

    static int n = reader.nextInt();
    static int[] steps = new int[n];
    static boolean[] winner = new boolean[n];
    static boolean[] black = new boolean[n];
    static ArrayList<Integer>[] accessible = new ArrayList[n];
    static ArrayList<Integer>[] accessibleUp = new ArrayList[n];
    static int[] accessibleWins = new int[n];

    static void update(int x, boolean isBlack) {
        if(black[x]==isBlack)
            return;
        black[x] = isBlack;
        if(isBlack) {
            for (Integer i : accessibleUp[x]) {
                accessibleWins[i]++;
                if(black[i]){
                    update(i,false);
                }
            }
        } else {
            for(Integer i : accessibleUp[x]) {
                accessibleWins[i]--;
                if(accessibleWins[i]==0)
                    update(i,true);
            }
        }
    }

    public static void main(String[] args) {
        for (int i = 0; i < n; i++) {
            accessible[i] = new ArrayList<>();
            accessibleUp[i] = new ArrayList<>();
        }
        for (int i = 0; i < n; i++) {
            String s = reader.nextLine();
            for (int j = 0; j < 8; j++) {
                steps[i] <<= 1;
                if (s.charAt(j) == 'W')
                    steps[i] += 1;
            }
        }

        for (int i = 1; i < n; i++) {
            for (int j = 1; j <= 8 && i - j >= 0; j++) {
                int common = common(steps[i], steps[i - j]);
                if (j <= common) {
                    accessible[i - j].add(i);
                    accessibleUp[i].add(i - j);
                }
            }
            update(i,true);
            winner[i]=!black[0];
        }

        for (int i = 0; i <n; i++) {
            System.out.print(winner[i] ? 1 : 2);
        }
    }
}