#include <iostream>

using namespace std;

struct node
{
  int left, right;
  int min, max, key;
  int count;
};

int calls;
node *nodes;

int lookup(int i, int L, int R)
{
  calls++;
  //cout << "lookup\t" << i << ' ' << L << ' ' << R << (i ? '\t' : '\n');
  if (i == 0)
  {
    return 0;
  }
  node *v = nodes + i;
  //cout << v->key << ' ' << v->count << ' ' << v->min << ' ' << v->max << '\n';

  if (L <= v->min && v->max <= R)
  {
    return v->count;
  }

  if (v->max < L || R < v->min)
  {
    return 0;
  }

  int res = 0;
  if (L <= v->key && v->key <= R)
  {
    res += 1;
  }

  res += lookup(v->left, L, R);
  res += lookup(v->right, L, R);
  return res;
}

bool fill(int i, int &min, int &max, int &count)
{
  if (i == 0)
  {
    return false;
  }
  node *v = nodes + i;

  int lMin = 0, lMax = 0, lCount = 0;
  if (fill(v->left, lMin, lMax, lCount))
  {
    if (lMax > v->max)
      v->max = lMax;

    if (lMin < v->min)
      v->min = lMin;

    v->count += lCount;
  }

  lMin = lMax = lCount = 0;
  if (fill(v->right, lMin, lMax, lCount))
  {
    if (lMax > v->max)
      v->max = lMax;

    if (lMin < v->min)
      v->min = lMin;

    v->count += lCount;
  }

  min = v->min;
  max = v->max;
  count = v->count;
  return true;
}

int main()
{
  ios_base::sync_with_stdio(false);
  cout.tie(0);
  cin.tie(0);

  int n, q, il, ir, ik, L, R;
  cin >> n;
  nodes = new node[n + 1];
  nodes[0];

  for (int i = 1; i <= n; i++)
  {
    cin >> il >> ir >> ik;
    nodes[i] = {il, ir, ik, ik, ik, (il != 0 && ir != 0)};
  }

  {
    int min = 0, max = 0, count = 0;
    fill(1, min, max, count);
  }

  /* for (int i = 1; i <= n; i++)
  {
    node *v = nodes + i;
    cout << i << '\t' << v->left << ' ' << v->right << ' '
         << v->key << '\t' << v->count << ' ' << v->min << ' ' << v->max << '\n';
  } */

  cin >> q;
  for (int i = 0; i < q; i++)
  {
    cin >> L >> R;
    calls = 0;
    lookup(1, L, R);
    cout << calls << '\n';
  }

  return 0;
}
