#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

#define E1 10
#define E2 100
#define E3 1000
#define E4 10000
#define E5 100000
#define E6 1000000
#define E7 10000000

using namespace std;

void solve();

int main() {
#ifdef MYDEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(false);
	cout.precision(12);
	solve();
}

bool game_over = false;

//		  Lchild Rchild    Head
pair<int, int> v[E5 + 1];
int w[E5 + 1]; // weight

int last_index = 1;
int get_new_index() {
	last_index++;
	return last_index;
}

void build_tree(int index, int k1, int k2) {
	if (game_over) {
		return;
	}
	if (k1 == 0 && k2 == 0) {
		return;
	}
	int l1 = k1/2;
	int l2 = k2/2;
	int r1 = k1/2;
	int r2 = k2/2;
	k1 -= l1 + r1;
	k2 -= l2 + r2;

	if (k1 == 0 && k2 == 0) {
		if (l1 == 0) {
			game_over = true;
			return;
		}
		else {
			l1--;
			w[index] = 1;
		}
	}
	if (k1 == 0 && k2 == 1) {
		w[index] = 2;
	}
	if (k1 == 1 && k2 == 0) {
		w[index] = 1;
	}
	if (k1 == 1 && k2 == 1) {
		l1++;
		w[index] = 2;
	}
	
	if (l1 + l2 + r1 + r2 == 0) { // no child
		v[index] = make_pair(0, 0);
		return;
	}
	else {
		int l_index = (l1 + l2 == 0) ? 0 : get_new_index();
		int r_index = (r1 + r2 == 0) ? 0 : get_new_index();
		v[index] = make_pair(l_index, r_index);
		build_tree(l_index, l1, l2);
		build_tree(r_index, r1, r2);
	}
}

void solve() {
	int a, b;
	cin >> a >> b;
	build_tree(1, a, b);
	if (game_over) {
		cout << -1;
		return;
	}
	for (int i = 1; i <= a + b; i++) {
		cout << w[i] << " " << v[i].first << " " << v[i].second << endl;
	}
}