#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>
#include <bitset>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <queue>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ul = unsigned long long;
using ld = long double;

struct pt {
    ld x, y;
    pt() : x(0), y(0) {}
    pt(ld x, ld y) : x(x), y(y) {}

    pt operator-(pt p) {
        return {x - p.x, y - p.y};
    }
    pt operator+(pt p) {
        return {x + p.x, y + p.y};
    }

    ld operator*(pt p) {
        return x * p.y - y * p.x;
    }

    pt operator*(ld k) {
        return {x * k, y * k};
    }
};

const int N = 2000001, MOD = 1e9 + 7;
ld eps = 1e-8;
ll f[N], rf[N], mn, mx;

ll pw(ll x, ll k) {
    ll r = 1;
    while (k) {
        if (k & 1)
            r = r * x % MOD;
        k >>= 1;
        x = x * x % MOD;
    }
    return r;
}

ll cc(ll n, ll k) {
    return f[n] * rf[k] % MOD * rf[n - k] % MOD;
}

pt inter(pt a1, pt b1, pt a2, pt b2) {
    ld s1 = (a2 - a1) * (b2 - a1), s2 = (a2 - b1) * (b2 - b1);
    return a1 + (b1 - a1) * (s1 / (s1 - s2));
}

pt p, v {1, 1};

void ck(pt a, pt b) {
    if (v * (b - a) > eps) {
        if (v * (a - p) < eps && v * (b - p) > -eps) {
            pt q = inter(p, p + v, a, b);
            mx = min(mx, (ll) (q.y + eps));
        }
    }
    else if (v * (b - a) < -eps) {
        if (v * (b - p) < eps && v * (a - p) > -eps) {
            pt q = inter(p, p + v, a, b);
            mn = max(mn, (ll) floor(q.y - eps) + 1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    f[0] = 1;
    for (int i = 1; i < N; i++)
        f[i] = f[i - 1] * i % MOD;
    rf[N - 1] = pw(f[N - 1], MOD - 2);
    for (int i = N - 1; i > 0; i--)
        rf[i - 1] = rf[i] * i % MOD;
    int t;
    cin >> t;
    pt a, b, c;
    rep(z, t) {
        cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
        if ((b - a) * (c - a) < 0)
            swap(b, c);
        ll ans = 0;
        for (int i = 0; ; i++) {
            p = {-i, i};
            if ((a - p) * v > eps && (b - p) * v > eps && (c - p) * v > eps)
                break;
            mn = i;
            mx = N - 1;
            ck(a, b);
            ck(b, c);
            ck(c, a);
            ans = (ans + cc(mx + 1, i + 1) - cc(mn, i + 1) + MOD) % MOD;
        }
        cout << ans << '\n';
    }
}

