#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>
#include <bitset>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <queue>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ul = unsigned long long;
using ld = long double;

const int N = 102;
ll d[N], h[N], n, l;
ld g[N][N], inf = 1e9, eps = 1e-8;

ld di(ld ax, ld ay, ld bx, ld by) {
    return sqrt(pow(ax - bx, 2) + pow(ay - by, 2));
}

int ck(ld ax, ld ay, ld bx, ld by) {
    if (di(ax, ay, bx, by) > l + eps)
        return 0;
    if (abs(ax - bx) < eps)
        return 1;
    if (ax > bx) {
        swap(ax, bx);
        swap(ay, by);
    }
    rep(i, n) {
        // cout << ax << ' ' << ay << ' ' << bx << ' ' << by << ' ' << i << ' ' << ay + (by - ay) * (d[i] - ax) / (bx - ax) << endl;
        if (ax - eps < d[i] && d[i] < bx + eps && ay + (by - ay) * (d[i] - ax) / (bx - ax) < h[i] - eps)
            return 0;
        if (ax - eps < d[i + 1] && d[i + 1] < bx + eps && ay + (by - ay) * (d[i + 1] - ax) / (bx - ax) < h[i] - eps)
            return 0;
    }
    return 1;
}

ld msqrt(ld x) {
    if (x < eps)
        return 0;
    return sqrt(x);
}

void rel(int i, int j, ld cd) {
    g[i][j] = min(g[i][j], cd);
    g[j][i] = min(g[j][i], cd);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(11);
    cin >> n >> l;
    for (int i = 1; i <= n; i++)
        cin >> d[i];
    rep(i, n)
        cin >> h[i];
    int m = 2 * n;
    rep(i, m)
        rep(j, m)
            g[i][j] = inf;
    rep(i, 2 * n)
        rep(j, i) {
            ld ax = d[(i + 1) / 2], ay = h[i / 2], bx = d[(j + 1) / 2], by = h[j / 2];
            if (ck(bx, by, ax, ay) || i / 2 == j / 2) {
                rel(i, j, di(ax, ay, bx, by));
            }
        }
    rep(i, n)
        rep(j, i) {
            ld dy = abs(h[i] - h[j]);
            if (dy > l)
                continue;
            if (h[j] > h[i]) {
                ld x = d[j + 1] + msqrt(l * l - dy * dy), y = h[i];
                if (x <= d[i] || x >= d[i + 1] || !ck(d[j + 1], h[j], x, y))
                    continue;
                rep(k, 2 * n) {
                    ld bx = d[(k + 1) / 2], by = h[k / 2];
                    if (k / 2 == i || ck(x, y, bx, by))
                        rel(j * 2 + 1, k, l + di(x, y, bx, by));
                }
            }
            else {
                ld x = d[i] - msqrt(l * l - dy * dy), y = h[j];
                if (x <= d[j] || x >= d[j + 1] || !ck(x, y, d[i], h[i]))
                    continue;
                rep(k, 2 * n) {
                    ld bx = d[(k + 1) / 2], by = h[k / 2];
                    if (k / 2 == j || ck(x, y, bx, by))
                        rel(i * 2, k, l + di(x, y, bx, by));
                }
            }
        }
    rep(i, n)
        rep(j, i)
            rep(k, j) {
                if (h[j] > h[i] - eps || h[j] > h[k] - eps)
                    continue;
                ld x = d[k + 1] + (d[i] - d[k + 1]) * (ld) (h[k] - h[j]) / (h[k] - h[j] + h[i] - h[j]), y = h[j];
                if (d[j] < x && x < d[j + 1] && ck(d[k + 1], h[k], x, y) && ck(x, y, d[i], h[i]))
                    rel(k * 2 + 1, i * 2, di(d[k + 1], h[k], x, y) + di(x, y, d[i], h[i]));
                ld d1 = abs(h[k] - h[j]), d2 = abs(h[i] - h[j]);
                if (d1 > l || d2 > l)
                    continue;
                ld ax = d[k + 1] + msqrt(l * l - d1 * d1), ay = h[j];
                ld bx = d[i] - msqrt(l * l - d2 * d2), by = h[j];
                if (d[j] < ax && bx < d[j + 1] && ax < x && ck(d[k + 1], h[k], ax, ay) && ck(bx, by, d[i], h[i])) {
                    rel(k * 2 + 1, i * 2, l * 2 + abs(ax - bx));
                }
            }
    rep(i, m)
        rep(j, m)
            rep(k, m)
                g[j][k] = min(g[j][k], g[j][i] + g[i][k]);
    if (g[0][m - 1] > inf / 2)
        cout << -1;
    else
        cout << g[0][m - 1];
}

