// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const double PI = atan2(0, -1);

template<typename T>
struct point {
	T x, y;
	point(T _x, T _y) : x(_x), y(_y) {}
	template<typename T2>
	point(point<T2> other) : x(other.x), y(other.y) {}

	point<T> operator+(point<T> const& other) const {
		return point<T>(x + other.x, y + other.y);
	}

	point<T> operator-(point<T> const& other) const {
		return point<T>(x - other.x, y - other.y);
	}

	point<T> ort() const {
		return point<T>(-y, x);
	}

	point<T> operator*(T num) const {
		return point<T>(x * num, y * num);
	}

	T len2() const {
		return x * x + y * y;
	}

	double len() const {
		return sqrt(len2());
	}

	double ang() const {
		return atan2(y, x);
	}
};

template<typename T>
ostream& operator<<(ostream& o, point<T> const& p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

template<typename T>
T cross(point<T> const& p1, point<T> const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

struct line {
	double a, b, c;
	line(point<int> const& p1, point<int> const& p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = -(a * p1.x + b * p1.y);
		double tmp = sqrt(a * a + b * b);
		a /= tmp; b /= tmp; c /= tmp;
	}

	double dist(point<double> const& p) const {
		return p.x * a + p.y * b + c;
	}

	point<double> ort() const {
		return point<double>(a, b);
	}
};

point<double> intersection(line const& l1, line const& l2) {
	double d = l1.a * l2.b - l1.b * l2.a;
	double d1 = -l1.c * l2.b + l1.b * l2.c;
	double d2 = -l1.a * l2.c + l1.c * l2.a;
	return point<double>(d1 / d, d2 / d);
}

pair<point<double>, point<double>> intersection(line const& l, point<double> const& c, double r) {
	double d = l.dist(c);
	double shift = sqrt(max(0.0, r * r - d * d));
	point on_line = c - l.ort() * d;
	assert(abs(l.dist(on_line)) <= 1e-3);
	point<double> v = l.ort().ort();
	return {on_line + v * shift, on_line - v * shift};
}

double norm(double ang) {
	while (ang < -PI) {
		ang += PI * 2;
	}
	while (ang >= PI) {
		ang -= PI * 2;
	}
	return ang;
}

const double eps = 1e-9;

void solve() {
	int n, l;
	cin >> n >> l;
	vector<int> arrd = {0};
	for (int i = 0; i < n; ++i) {
		int d;
		cin >> d;
		arrd.push_back(d);
	}
	vector<int> arrh;
	for (int i = 0; i < n; ++i) {
		int h;
		cin >> h;
		arrh.push_back(h);
	}

	vector<point<int>> angles;
	for (int i = 0; i < n; ++i) {
		angles.push_back(point<int>(arrd[i], arrh[i]));
		angles.push_back(point<int>(arrd[i + 1], arrh[i]));
	}

	auto check_seg = [&](point<double> p1, point<double> p2) {
		if ((p1 - p2).len() > l + eps) {
			return false;
		}
		if (p1.x > p2.x) {
			swap(p1.x, p2.x);
		}
		if (abs(p1.x - p2.x) < eps) {
			return true;
		}
		for (auto p : angles) {
			if (p1.x - eps < p.x && p.x < p2.x + eps) {
				double y = (p1 + (p2 - p1) * ((p.x - p1.x) / (p2.x - p1.x))).y;
				if (y + eps < p.y) {
					return false;
				}
			}
		}
		return true;
	};

	vector<vector<pair<int, double>>> graph;
	auto add_node = [&]() {
		graph.push_back({});
		return szof(graph) - 1;
	};

	vector<vector<pair<double, int>>> on_seg(n);
	on_seg[0].push_back({0, add_node()});
	on_seg[n - 1].push_back({arrd.back(), add_node()});

	auto add_edge = [&](int ind1, point<double> p1, int ind2, point<double> p2) {
		// cerr << ind1 << " " << p1 << " " << ind2 << " " << p2 << endl;
		int v1 = add_node();
		int v2 = add_node();
		double len = (p2 - p1).len();
		graph[v1].push_back({v2, len});
		graph[v2].push_back({v1, len});
		on_seg[ind1].push_back({p1.x, v1});
		on_seg[ind2].push_back({p2.x, v2});
	};


	for (int i = 0; i < n; ++i) {
		for (int shift1 = 0; shift1 < 2; ++shift1) {
			point a = point<double>(shift1 == 0 ? arrd[i] : arrd[i + 1], arrh[i]);
			for (int j = i + 1; j < n; ++j) {
				for (int shift2 = 0; shift2 < 2; ++shift2) {
					point b = point<double>(shift2 == 0 ? arrd[j] : arrd[j + 1], arrh[j]);
					if (check_seg(a, b)) {
						add_edge(i, a, j, b);
					}
				}
			}

			for (int j = 0; j < n; ++j) {
				if (i == j) {
					continue;
				}
				point p1 = point<double>(arrd[j], arrh[j]);
				point p2 = point<double>(arrd[j + 1], arrh[j]);
				if (abs(arrh[i] - arrh[j]) <= l) {
					auto qq = intersection(line(p1, p2), a, l);
					if (p1.x - eps <= qq.ff.x && qq.ff.x <= p2.x + eps) {
						if (check_seg(a, qq.ff)) {
							add_edge(i, a, j, qq.ff);
						}
					}

					if (p1.x - eps <= qq.ss.x && qq.ss.x <= p2.x + eps) {
						if (check_seg(a, qq.ss)) {
							add_edge(i, a, j, qq.ss);
						}
					}
				}
			}
		}

		for (int j = i + 2; j < n; ++j) {
			point<double> a(arrd[i + 1], arrh[i]);
			point<double> b(arrd[j], arrh[j]);
			for (int q = i + 1; q < j; ++q) {
				int h = arrh[q];
				if (h < arrh[i] && h < arrh[j]) {
					point bb(arrd[j], h * 2 - arrh[j]);
					point qq = intersection(line(a, bb), line(point<double>(arrd[q], arrh[q]), point<double>(arrd[q + 1], arrh[q])));
					if (arrd[q] - eps < qq.x && qq.x < arrd[q + 1] + eps) {
						if (check_seg(a, qq)) {
							add_edge(i, a, q, qq);
						}
						if (check_seg(qq, b)) {
							add_edge(q, qq, j, b);
						}
					}
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		sort(on_seg[i].begin(), on_seg[i].end());
		for (int j = 0; j < szof(on_seg[i]) - 1; ++j) {
			int a = on_seg[i][j].ss;
			int b = on_seg[i][j + 1].ss;
			double len = on_seg[i][j + 1].ff - on_seg[i][j].ff;
			graph[a].push_back({b, len});
			graph[b].push_back({a, len});
		}
	}

	vector<double> dist(szof(graph), 1e100);
	int s = 0, t = 1;
	dist[s] = 0;
	set<pair<double, int>> st;
	st.insert({0, s});
	while (szof(st)) {
		int v = st.begin()->ss;
		st.erase(st.begin());
		for (auto to : graph[v]) {
			double val = dist[v] + to.ss;
			if (val < dist[to.ff]) {
				st.erase({dist[to.ff], to.ff});
				dist[to.ff] = val;
				st.insert({dist[to.ff], to.ff});
			}
		}
	}

	if (dist[t] > INF) {
		cout << "-1\n";
	} else {
		cout << dist[t] << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}