﻿/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/

#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const ll mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

const ll P = 1e9 + 7;
const ll Q = 150001;

mt19937 rng(228);

int build_tree(int A, int B, vector<pair<int, int>> &tree, vector<int> &labels) {
	if (A == 0 && B == 0) return -1;
	if (A < 0 || B < 0) return -2;
	int v = sz(tree);
	tree.pb(mp(-1, -1));
	if (B > 0) {
		labels.pb(2);
		B--;
	}
	else {
		labels.pb(1);
		A--;
	}

	if (A % 2 == 0) {
		if (B % 2 == 0) {
			tree[v].first = build_tree(A / 2, B / 2, tree, labels);
			tree[v].second = build_tree(A / 2, B / 2, tree, labels);
		}
		else {
			tree[v].first = build_tree(A / 2 + 1, B / 2, tree, labels);
			tree[v].second = build_tree(A / 2 - 1, B / 2 + 1, tree, labels);
		}
	}
	else {
		if (B % 2 == 0) {
			tree[v].first = build_tree(A / 2 + 1, B / 2, tree, labels);
			tree[v].second = build_tree(A / 2, B / 2, tree, labels);
		}
		else {
			tree[v].first = build_tree(A / 2 + 1, B / 2, tree, labels);
			tree[v].second = build_tree(A / 2, B / 2 + 1, tree, labels);
		}
	}

	if (tree[v].first == -2 || tree[v].second == -2) return -2;
	return v;
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int A, B;
	cin >> A >> B;

	vector<pair<int, int>> tree;
	vector<int> labels;

	int res = build_tree(A, B, tree, labels);

	if (res == -2) cout << -1 << endl;
	else {
		for (int i = 0; i < sz(tree); i++) {
			cout << labels[i] << ' ' << tree[i].first + 1 << ' ' << tree[i].second + 1 << endl;
		}
	}
}