﻿/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/

#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const ll mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

const ll P = 1e9 + 7;
const ll Q = 150001;

mt19937 rng(228);

vector<int> rabbit_hole(int s, vector<int> &children, vector<vector<int>> &chcodes) {
	if (s == sz(children) - 1) {
		vector<int> res(1, children[s]);
		for (auto el : chcodes[s]) res.pb(el);
		return res;
	}
	else {
		vector<int> res;
		auto seq = rabbit_hole(s + 1, children, chcodes);
		for (auto el : seq) res.pb(el);
		res.pb(children[s]);
		reverse(all(seq));
		for (auto el : seq) res.pb(el);
		for (auto el1 : chcodes[s]) {
			res.pb(el1);
			reverse(all(seq));
			for (auto el : seq) res.pb(el);
		}
		return res;
	}
}

vector<int> ctree(int v, vector<int> &p) {
	vector<int> children;
	for (int i = 0; i < sz(p); i++) if (p[i] == v) children.pb(i);
	
	vector<int> seq;
	if (sz(children) == 0) return seq;

	vector<vector<int>> chcodes;
	for (auto ch : children) chcodes.pb(ctree(ch, p));

	seq = rabbit_hole(0, children, chcodes);

	return seq;
}

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

void process_all_digits(int pos, int v, vector<int> &nums, vector<char> &dir_mtch, vector<int> &rev_mtch, vector<vector<int>> &dictree, vector<int> &amt, vector<int> &lnk, vector<int> &occ_cnt) {
	if (pos == sz(nums)) {
		if (lnk[v] != -1) occ_cnt[lnk[v]]++;
	}
	else {
		if (dir_mtch[nums[pos]] != ' ') {
			if (dictree[v][dir_mtch[nums[pos]] - 'A'] != -1)
				process_all_digits(pos + 1, dictree[v][dir_mtch[nums[pos]] - 'A'], nums, dir_mtch, rev_mtch, dictree, amt, lnk, occ_cnt);
		}
		else {
			for (char ch = 'A'; ch <= 'Z'; ch++) {
				if (rev_mtch[ch - 'A'] == -1 && dictree[v][ch - 'A'] != -1) {
					dir_mtch[nums[pos]] = ch;
					rev_mtch[ch - 'A'] = nums[pos];
					process_all_digits(pos + 1, dictree[v][dir_mtch[nums[pos]] - 'A'], nums, dir_mtch, rev_mtch, dictree, amt, lnk, occ_cnt);
					dir_mtch[nums[pos]] = ' ';
					rev_mtch[ch - 'A'] = -1;
				}
			}
		}
	}
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	// path: (-10, 0) -> (0, 0) -> (0, 20) -> (-1, 20) -> (-1, 1) -> (-11, 1) -> (-11, 0) -> (-10, -1) -> (-2, -1) -> (17, -20) -> ...

	vector<pair<int, int>> pathto270;
	for (int i = 0; i < 10; i++) pathto270.pb(mp(1, 0));
	for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
	pathto270.pb(mp(-1, 0));
	for (int i = 0; i < 19; i++) pathto270.pb(mp(0, -1));
	for (int i = 0; i < 10; i++) pathto270.pb(mp(-1, 0));
	pathto270.pb(mp(0, -1));
	pathto270.pb(mp(1, -1));
	for (int i = 0; i < 8; i++) pathto270.pb(mp(1, 0));
	for (int i = 0; i < 19; i++) pathto270.pb(mp(1, -1));
	// 12 -> top -> 11 -> bottom -> ...
	for (int x = 16; x >= 0; x--) {
		pathto270.pb(mp(-1, 0));
		if (x % 2 == 0) for (int i = 0; i < 18; i++) pathto270.pb(mp(-1, 1));
		else for (int i = 0; i < 18; i++) pathto270.pb(mp(1, -1));
	}
	// at (-18, 2)
	pathto270.pb(mp(-1, 1));
	pathto270.pb(mp(-1, 1));
	for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
	// 1 -> bottom -> 2 -> top -> ...
	for (int x = 1; x < 20; x++) {
		pathto270.pb(mp(1, 0));
		if (x % 2 == 0) for (int i = 0; i < 18; i++) pathto270.pb(mp(0, 1));
		else for (int i = 0; i < 18; i++) pathto270.pb(mp(0, -1));
	}

	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int n;
		cin >> n;

		int x = -10, y = 0;
		
		string token = "start";
		int pos = 0;
		while (token != "win" && token != "lose") {
			if (token == "move") {
				int tmp;
				cin >> tmp;
				cin >> tmp;
			}
			cout << pathto270[pos].first << ' ' << pathto270[pos].second << endl;
			
			x += pathto270[pos].first;
			y += pathto270[pos].second;

			//cout << "= " << x << ' ' << y << " =" << endl;

			cout.flush();
			cin >> token;
			if (pos < sz(pathto270) - 1) pos++;
			else break;
		}

		if (token == "lose") return 0;
	}
}