#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll linf = (ll)1e18 + 10;
const int iinf = (int)1e9 + 10;
const int mod = 998244353;
const int modd = 1000000007;
const ld PI = acos(-1);
#define all(x) x.begin(), x.end()

const int maxn = 5e5 + 10;
int tr[maxn], w[maxn], depth[maxn];
int used[maxn];

bool dfs(vector<vector <int>> & gr, vector <int> & w, int v, int & a, int  & b, int & summ){
    bool f = true;
    a = b = summ = 0;
    if (w[v] == 1) a++;
    if (w[v] == 2) b++;
    summ += w[v];
    vector <int> sums;
    for (auto u : gr[v]){
        if (u != 0){
            int a1, b1, summ1;
            f &= dfs(gr, w, u, a1, b1, summ1);
            a += a1, b += b1, summ += summ1;
            sums.push_back(summ1);
        }
        else{
            sums.push_back(0);
        }
    }
    if (sums.size() != 2 || abs(sums[0] - sums[1]) > 1) f = false;

    return f;
}

bool check(vector<vector <int>> gr, vector <int> w, int a, int b){
    int aa, bb, summ;
    return dfs(gr, w, 1, aa, bb, summ) && (a == aa) && (b == bb);
}

void gen_tree(int root, int sz, int ww){
    if (sz == 0) return;
    used[root] = ww;
    tr[root] = root / 2; w[root] = ww;
    depth[root] = depth[root / 2] + 1;
    gen_tree(2*root, sz / 2, ww);
    gen_tree(2*root + 1, (sz - 1) / 2, ww);
}

void gen_tree_x(int root, int sz, int ww){
    gen_tree(2*root, (sz+1) / 2, ww);
    gen_tree(2*root + 1, sz / 2, ww);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int a, b;
    cin >> a >> b;
    int aa = a, bb = b;

    if (b != 0) {

        gen_tree(1, b, 2);
        vector<int> cnt(maxn, 0);
        int dep = 0;
        for (int i = 0; i < maxn; i++) {
            if (used[i]){
                cnt[tr[i]]++;
                dep = max(dep, depth[i]);
            }
        }
        int c0 = 0, c1 = 0;
        for (int i = 0; i < maxn; i++) {
            if (used[i]) {
                if (cnt[i] == 1) c1++;
                if (cnt[i] == 0){
                    if (depth[i] != dep) c1 += 2;
                    else c0++;
                }
            }
        }
        if (a < c1) {
            cout << -1;
            return 0;
        }
        a -= c1;
        int left = a % (c0 + c1);
        for (int i = 0; i < 5; i++) cout << tr[i] << " ";
        cout << endl;
        cout << c0 << " " << c1 << " " << left << endl;
        for (int i = 0; i < maxn; i++){
            if (used[i] == 2) {
                if (cnt[i] == 0 && depth[i] != dep) {
                    if (left > 0) {
                        left--;
                        gen_tree_x(i, a / (c0 + c1) + 2, 1);
                    } else {
                        gen_tree_x(i, a / (c0 + c1) + 1, 1);
                    }
                }
            }
        }
        for (int i = 0; i < maxn; i++) {
            if (used[i] == 2) {
                if (cnt[i] == 1) {
                    if (left > 0) {
                        left--;
                        gen_tree(2 * i + 1, a / (c0 + c1) + 2, 1);
                    } else {
                        gen_tree(2 * i + 1, a / (c0 + c1) + 1, 1);
                    }
                }
            }
        }
        for (int i = 0; i < maxn; i++) {
            if (used[i] == 2 && cnt[i] == 0 && depth[i] == dep) {
                if (left > 0) {
                    left--;
                    gen_tree_x(i, a / (c0 + c1) + 1, 1);
                } else {
                    gen_tree_x(i, a / (c0 + c1), 1);
                }
            }
        }
    }
    else{
        gen_tree(1, a, 1);
    }

    int ii = 1;
    vector <int> newnum(maxn), neww(maxn);
    vector <vector <int>> gr(maxn);
    for (int i = 0; i < maxn; i++){
        if (used[i]){
            newnum[i] = ii; ii++;
            gr[newnum[tr[i]]].push_back(newnum[i]);
            neww[newnum[i]] = w[i];
        }
    }
    for (int i = 0; i < maxn; i++){
        if (used[i]){
            int ind = newnum[i];
            while (gr[ind].size() < 2) gr[ind].push_back(0);
            cout << neww[newnum[i]] << " " << gr[ind][0] << " " << gr[ind][1] << "\n";
        }
    }

    cout << endl;

    assert(check(gr, neww, aa, bb));

    return 0;
}