#include <bits/stdc++.h>
using namespace std;

#define llong long long 
#define len(x) ((int)x.size())
#define rep(i,n) for (int i = -1; ++ i < n; )
#define rep1(i,n) for (int i = 0; i ++ < n; )
#ifdef testing
mt19937 rng(177013);
#else
mt19937 rng(chrono::system_clock::now().time_since_epoch().count());
#endif
#define rand() (int)(rng() >> 1)
#define CONCAT_(x, y) x##y/*{{{*/
#define CONCAT(x, y) CONCAT_(x, y)
#define SPEC(name) CONCAT(name, __LINE__)
#ifdef LOCAL_DEBUG   
int __db_level = 0;
#define clog cerr << string(__db_level * 2, ' ')
struct debug_block {
    string msg;
    debug_block(const string& s): msg(s) { clog << "{ " << msg << endl; ++__db_level; }
    ~debug_block() { --__db_level; clog << "} " << msg << endl; }
};
#define DB(args...) stringstream SPEC(ss); SPEC(ss)<< args; debug_block SPEC(dbbl)(SPEC(ss).str())
#else
#define clog if (0) cerr
#define DB(...)
#endif
#define db(val) "[" #val " = " << val << "]; "
template<class U, class V> ostream& operator<<(ostream& out, const pair<U, V>& p) {
    return out << "(" << p.first << ", " << p.second << ")";
}
template<size_t i, class T> ostream& print_tuple_utils(ostream& out, const T& tup) {
    if constexpr(i == tuple_size<T>::value) return out << ")";
    else return print_tuple_utils<i + 1, T>(out << (i ? ", " : "(") << get<i>(tup), tup);
}
template<class ...U>
ostream& operator<<(ostream& out, const tuple<U...>& tup) { return print_tuple_utils<0, tuple<U...>>(out, tup); }
template<class, typename = void> struct has_const_iterator : false_type {};
template<class T> struct has_const_iterator<T, void_t<typename T::const_iterator>> : true_type {};
template<class T>
typename enable_if<has_const_iterator<T>::value && !is_same<T, string>::value, ostream&>::type
operator<<(ostream& out, const T& container) { 
    auto beg = container.begin(), end = container.end();
    out << "(" << container.size() << ") {";
    if (beg != end) out << *(beg++);
    while (beg != end) out << ", " << *(beg++);
    return out << "}";
}
#define ptrtype(x) typename iterator_traits<x>::value_type
template<class u> vector<ptrtype(u)> $v(u a, u b) { return vector<ptrtype(u)>(a, b); }/*}}}*/
// ACTUAL SOLUTION START HERE ////////////////////////////////////////////////////////////////

struct Interval {
    llong l, r;
    int id;
    Interval() = default;
    Interval(llong l_, llong r_, int i) : l(l_), r(r_), id(i) {}
    
    friend ostream& operator<<(ostream& out, const Interval& u) {
        return out << "(" << u.l << ", " << u.r << ", " << u.id << ")";
    }
};

bool cmp_l(const Interval& u, const Interval& v) {
    if (u.l == v.l) return u.r < v.r;
    return u.l < v.l;
}

bool cmp_r(const Interval& u, const Interval& v) {
    if (u.r == v.r) return u.l < v.l;
    return u.r < v.r;
}

const int maxn = 202020;
int n, q;
vector<int> children[maxn];
int key[maxn];
vector<Interval> node_ranges;
vector<Interval> qr_ranges;

Interval dfs(int u) {
    Interval r(key[u], key[u], u);
    for (auto v: children[u]) {
        if (!v) continue;
        auto cr = dfs(v);
        r.l = min(r.l, cr.l);
        r.r = max(r.r, cr.r);
    }
    node_ranges.push_back(r);
    return r;
}

struct BIT {
    vector<llong> sum;
    BIT(int sz): sum(sz + 10) {}
    llong get(int p) {
        llong ans = 0;
        for (++p; p > 0; p -= p & -p) ans += sum[p];
        return ans;
    }
    
    void upd(int p, llong val) {
        for (++p; p < len(sum); p += p & -p) sum[p] += val;
    }
};

int main(void) {
#ifdef LOCAL
    freopen("main.inp", "r", stdin);
    freopen("main.out", "w", stdout);
    freopen(".log", "w", stderr);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    rep1(i, n) {
        int l, r; cin >> l >> r >> key[i];
        children[i].push_back(l);
        children[i].push_back(r);
    }
    
    cin >> q;
    qr_ranges.resize(q);
    rep(i, q) {
        cin >> qr_ranges[i].l >> qr_ranges[i].r;
        qr_ranges[i].id = i;
    }
    vector<int> ans(q, n);
            
    dfs(1);
    clog << db(node_ranges) << endl;
    
    sort(node_ranges.begin(), node_ranges.end(), cmp_r);
    sort(qr_ranges.begin(), qr_ranges.end(), cmp_l);
    
    int ptr = 0;
    clog << "lower" << endl;
    clog << db(node_ranges) << endl;
    clog << db(qr_ranges) << endl;
    for (auto [l, r, id]: qr_ranges) {
        while (ptr < n and node_ranges[ptr].r < l) ++ptr;
        ans[id] -= ptr;
        clog << db(id) << db(l) << db(r) << db(ptr) << endl;
    }
    
    sort(node_ranges.rbegin(), node_ranges.rend(), cmp_l);
    sort(qr_ranges.rbegin(), qr_ranges.rend(), cmp_r);
    ptr = 0;
    clog << "upper" << endl;
    clog << db(node_ranges) << endl;
    clog << db(qr_ranges) << endl;
    for (auto [l, r, id]: qr_ranges) {
        while (ptr < n and node_ranges[ptr].l > r) ++ptr;
        ans[id] -= ptr;
        clog << db(id) << db(l) << db(r) << db(ptr) << endl;
    }
    
    
    vector<llong> r_values;
    for (auto [l, r, id]: node_ranges) r_values.push_back(r);
    for (auto [l, r, id]: qr_ranges) r_values.push_back(r);
    sort(r_values.begin(), r_values.end());
    r_values.erase(unique(r_values.begin(), r_values.end()), r_values.end());
    auto index = [&](llong& num) {
        num = lower_bound(r_values.begin(), r_values.end(), num) - r_values.begin();
    };
    
    ptr = 0;
    BIT bit(len(r_values));
    sort(node_ranges.rbegin(), node_ranges.rend(), cmp_l);
    sort(qr_ranges.rbegin(), qr_ranges.rend(), cmp_l);
    clog << "mid" << endl;
    for (auto [l, r, id]: qr_ranges) {
        while (ptr < n and node_ranges[ptr].l >= l) {
            llong cur_r = node_ranges[ptr].r;
            index(cur_r);
            bit.upd((int)cur_r, 1);
            ++ptr;
        }
        
        index(r);
        llong cnt = bit.get((int)r);
        ans[id] -= (int)cnt;
        clog << db(id) << db(cnt) << endl;
    }
    
    for (auto i: ans) cout << (2 * i + 1) << '\n';
    
    return 0;
}

// vim: foldmethod=marker

