#include <algorithm>
#include <bitset>
#include <iostream>
#include <iterator>
#include <random>
#include <set>
#include <vector>

// #define FAST_ALLOCATOR_MEMORY 256000000
// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

// #define USE_INT128
// #define int int64_t

// #undef _DEBUG

#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()

#ifdef USE_INT128
#define lint __int128
#define ulint __int128
#else
#define lint int64_t
#define ulint int64_t
#endif

typedef long double ld;
// #define f first
// #define s second
typedef pair<int, int> pint;

const int inf = 1 << 30;

template <class T>
T mineq(T& a, const T& b) {
    return a = min(a, b);
}

template <class T>
T maxeq(T& a, const T& b) {
    return a = max(a, b);
}

mt19937 rd(533);
// end of default file

const int w = 8;
const int MASK = (1 << w) - 1;

vector<bool> solve(vector<int> stair, int n) {
    auto canmove = [&stair](int i, int j) {
        int maxd = w - __builtin_popcount(stair[i] ^ stair[j]);
        return maxd >= (j - i);
    };

    vector<bool> win(1 << w);
    for (int i = 1; i < (1 << w); i += 2) {
        win[i] = i & 1;
    }

    vector<bool> ans(n);
    for (int d = 0; d < min(w, n); d++) {
        bool true_winnable[d + 1] = {};
        for (int p = d; p >= 0; p--) {
            for (int to = p + 1; to <= d; to++)
                true_winnable[p] |= !true_winnable[to] && canmove(p, to);
        }
        ans[d] = true_winnable[0];
    }

    for (int r = w; r < n; r++) {
        int l = r - w + 1;

        vector<int> moves;
        for (int to = 0; to < w; to++) {
            if (canmove(l - 1, l + to))
                moves.push_back(to);
        }

        vector<bool> winn(1 << w);
        for (int mask = 0; mask < 1 << w; mask++) {
            bool winnable = false; // l-1 winnable
            for (int to : moves) {
                if (!(mask & (1 << to))) {
                    winnable = true;
                }
            }
            int old_mask = ((mask << 1) & MASK) + winnable;
            winn[mask] = win[old_mask];
        }
        win = winn;

        bool true_winnable[w] = {};
        for (int p = w - 1; p >= 0; p--) {
            for (int to = p + 1; to < w; to++)
                true_winnable[p] |= !true_winnable[to] && canmove(l + p, l + to);
        }

        int true_mask = 0;
        for (int i = 0; i < w; i++) true_mask |= (true_winnable[i] << i);
        ans[r] = win[true_mask];
    }
    return ans;
}

vector<bool> dumb_solve(vector<int> stair, int n) {
    vector<bool> ans(n);
    auto canmove = [&stair](int i, int j) {
        int maxd = w - __builtin_popcount(stair[i] ^ stair[j]);
        return maxd >= (j - i);
    };

    for (int r = 0; r < n; r++) {
        bool win[r + 1] = {};
        for (int p = r; p >= 0; p--) {
            for (int to = p + 1; to <= p + w && to <= r; to++) {
                win[p] |= !win[to] && canmove(p, to);
            }
        }
        ans[r] = win[0];
    }
    return ans;
}


void stress() {
    for (int it = 0; it < 100000; it++) {
        int n = 20;
        vector<int> stair(n);
        for (auto& i : stair)
            i = rand() & MASK;
        auto a1 = solve(stair, n);
        auto a2 = dumb_solve(stair, n);
        if (a1 != a2) {
            cerr << "!";
        }
    }
}

int32_t main() {
    srand(5332017);
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cout << fixed;
    cout.precision(1); // !!

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    stress();
#endif

    int n;
    cin >> n;

    vector<int> stair(n);
    for (auto& st : stair) {
        string s;
        cin >> s;
        for (auto& c : s) {
            st = (st << 1) + (c == 'R');
        }
    }

    auto ans = solve(stair, n);

    #ifdef _DEBUG
    auto a2 = dumb_solve(stair, n);
    if (ans != a2) {
        cout << "!!!!" << n << "\n";
        cout << "Correct:\n";
        for (int i : a2) cout << 2 - (int)i;
        cout << "\nWas:\n";
    }
#endif

    for (auto i : ans) cout << 2 - (int)i;
    cout << endl;
}
