﻿#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <iomanip>
#include <array>
#include <numeric>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <queue>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <cassert>

#define all(a) (a).begin(), (a).end()

using namespace std;
using ll = long long;
using ld = long double;

const int N = 4e5 + 228;
const int inf = 1e9 + 228;

int base_n;
int n;
vector<int> g[N];
int val[N];
vector<pair<int, int>> qs;

void read(istream& cin) {
	cin >> n;
	base_n = n;
	int nn = n;
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r >> val[i];
		--l; --r;
		if (l != -1) {
			g[i].push_back(l);
		}
		else {
			g[i].push_back(nn++);
			val[nn - 1] = inf;
		}
		if (r != -1) {
			g[i].push_back(r);
		}
		else {
			g[i].push_back(nn++);
			val[nn - 1] = inf;
		}
	}
	n = nn;
	int q;
	cin >> q;
	qs.resize(q);
	for (auto& q : qs) {
		cin >> q.first >> q.second;
	}
}

struct ST {
	int n;
	vector<int> t;
	ST(int n) : n(n), t(2 * n) {}
	void upd(int v, int x) {
		t[v += n] += x;
		for (v >>= 1; v; v >>= 1) {
			t[v] = t[v << 1] + t[v << 1 | 1];
		}
	}
	int get(int l, int r) {
		int ret = 0;
		for (l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
			if (l & 1) {
				ret += t[l];
			}
			if (!(r & 1)) {
				ret += t[r];
			}
		}
		return ret;
	}
};

int lo[N], hi[N];

void dfs(int v) {
	lo[v] = hi[v] = val[v];
	for (int to : g[v]) {
		dfs(to);
		if (to < base_n) {
			lo[v] = min(lo[v], lo[to]);
			hi[v] = max(hi[v], hi[to]);
		}
	}
}

struct Ev {
	int l, r;
	int id; // -1 iff vertex
	int add;
};

bool cmp_inside(Ev a, Ev b) {
	return a.r < b.r || a.r == b.r && a.id < b.id;
}

bool cmp_left(Ev a, Ev b) {
	int x = (a.id == -1 ? a.r : a.l);
	int y = (b.id == -1 ? b.r : b.l);
	return (x < y || x == y && a.id > b.id);
}

bool cmp_right(Ev a, Ev b) {
	int x = (a.id == -1 ? a.l : a.r);
	int y = (b.id == -1 ? b.l : b.r);
	return (x > y || x == y && a.id > b.id);
}

void solve(ostream& cout) {
	dfs(0);
	vector<int> keks;
	for (int i = 0; i < n; i++) {
		keks.push_back(lo[i]);
		keks.push_back(hi[i]);
	}
	for (auto q : qs) {
		keks.push_back(q.first);
		keks.push_back(q.second);
	}
	sort(all(keks));
	keks.erase(unique(all(keks)), keks.end());
	for (int i = 0; i < n; i++) {
		lo[i] = lower_bound(all(keks), lo[i]) - keks.begin();
		hi[i] = lower_bound(all(keks), hi[i]) - keks.begin();
	}
	for (auto& q : qs) {
		q.first = lower_bound(all(keks), q.first) - keks.begin();
		q.second = lower_bound(all(keks), q.second) - keks.begin();
	}

	vector<int> ans(qs.size(), n);
	{
		vector<Ev> evs;
		for (int i = 0; i < base_n; i++) {
			evs.push_back({ lo[i], hi[i], -1, (int)g[i].size() });
		}
		for (int i = 0; i < qs.size(); i++) {
			evs.push_back({ qs[i].first, qs[i].second, i, 0 });
		}
		sort(all(evs), cmp_inside);
		ST t(keks.size());
		for (auto e : evs) {
			if (e.id == -1) {
				t.upd(e.l, +e.add);
			}
			else {
				ans[e.id] -= t.get(e.l, e.r);
			}
		}
	}
	{
		vector<Ev> evs;
		for (int i = 0; i < base_n; i++) {
			evs.push_back({ lo[i], hi[i], -1, (int)g[i].size() });
		}
		for (int i = 0; i < qs.size(); i++) {
			evs.push_back({ qs[i].first, qs[i].second, i, 0 });
		}
		sort(all(evs), cmp_left);
		int cnt = 0;
		for (auto e : evs) {
			if (e.id == -1) {
				cnt += +e.add;
			}
			else {
				ans[e.id] -= cnt;
			}
		}
	}
	{
		vector<Ev> evs;
		for (int i = 0; i < base_n; i++) {
			evs.push_back({ lo[i], hi[i], -1, (int)g[i].size() });
		}
		for (int i = 0; i < qs.size(); i++) {
			evs.push_back({ qs[i].first, qs[i].second, i, 0 });
		}
		sort(all(evs), cmp_right);
		int cnt = 0;
		for (auto e : evs) {
			if (e.id == -1) {
				cnt += +e.add;
			}
			else {
				ans[e.id] -= cnt;
			}
		}
	}
	for (auto x : ans) {
		cout << x << '\n';
	}
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int tc = 1;
	// cin >> tc;
	while (tc--) {
		read(cin);
		solve(cout);
	}
}
