#include <iostream>
#include <string>
#include <queue>
#include <cmath>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <cstring>
#include <vector>
#include <cstdlib>
 
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

int n, m, d[100002], b[100002], c[100002];

template <class T>
struct nodeTree {
    nodeTree* left;
    nodeTree* right;
    int key;
    T value;
    int sum;
    nodeTree(T v, int k, nodeTree* l = NULL, nodeTree* r = NULL) {
        value = v;
        key = k;
        left = l;
        right = r;
        sum = 0;
    }
};

template <class T>
class binSTree {
    nodeTree<T>* first;


public:
    binSTree() {
        first = NULL;
    }

    void insert(nodeTree<T>* q) {
        nodeTree<T>* u = q;
        if(empty()) {
            first = u;
            return;
        }
        nodeTree<T>* g = first;
        while(true) {
            if(!g->right) {
                g->sum += q->key;
                g->right = q;
                break;
            }
            else if(!g->left) {
                g->sum -= q->key;
                g->left = q;
                break;
            }
            else { 
                if(g->sum <= 0) {
                    g->sum += q->key;
                    g = g->right;
                }
                else {
                    g->sum -= q->key;
                    g = g->left;
                }
            }
            
        }
    }

    bool empty() const {
        if(first)
            return false;
        return true;
    }

    void preorder() {
        std::stack<nodeTree<T>*> a;
        a.push(first);
        bool t = 1;
        nodeTree<T>* q = first;
        while(1) {
            if(!q)
                return;
            d[q->value] = q->key;
            if(q->right)
                b[q->value] = (q->right)->value;
            else
                b[q->value] = 0;
            if(q->left)
                c[q->value] = (q->left)->value;
            else
                c[q->value] = 0;
            
            if(q->left && t) {
                q = q->left;
                a.push(q);
            }
            else if(q->right) {
                a.pop();
                q = q->right;
                a.push(q);
                t = 1;
            }
            else {
                a.pop();
                if(a.empty()) {
                    return;
                }
                
                q = a.top();
                t = 0;
            }
        }
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    binSTree<int> z;
    if(n == 0 && m%2 == 0)
        cout<<"-1"<<endl;
    else {
        for(int i = 0;i < n + m; ++i) {
            int x;
            if(i < m) {
                x = 2;
            }
            else {
                x = 1;
            }
            nodeTree<int>* q = new nodeTree<int>(i + 1, x);
            z.insert(q);
        }
        z.preorder();
        for(int i = 1;i <= n + m; ++i) {
            cout<<d[i]<<" "<<b[i]<<" "<<c[i]<<endl;
        }
    }
	return 0;
}