#include <iostream>
#include <algorithm>
#include <cmath>
#include <cassert>

using lint = long long;
lint gcd (lint a, lint b) {
    if (a == 0) {
        return b;
    }
    return gcd (b%a, a);
}

lint solve(lint b, lint d) {
    lint g = gcd(b, d);

    lint l = (b * d) / g;

    return (b * b - b) / l;
}

int main() {

    int tc;
    std::cin >> tc;

    while (tc--) {
        lint b, d;
        std::cin >> b >> d;
        lint res = solve(b, d);
        std::cout << res << '\n';
    }


    return 0;
}

/*
#include <cstring>
#include <iostream>
#include <vector>
#include <algorithm>


int par[20];
int n;
std::vector<int> g[1 << 20];

int is_beautiful(int mask) {
    // root is red
    if (!(mask & 1)) return false;

    for (int i = 1; i < n; ++i) {
        // if i is red then par[i] must be too
        if ((mask & (1 << i)) && !(mask & (1 << par[i]))) {
            return false;
        }
    }

    return true;
}

//int p[1 << 20];
//void dfs(int v) {
//    for (int i = 0; i < g[v].size(); ++i) {
//        int to = g[v][i];
//        if (!used[to]) {
//            p[to] = v;
//            used[to] = used[v] + 1;
//            dfs(to);
//        }
//    }
//}

int used_order[1 << 20];
std::vector<int> order;
void dfs_order(int v) {
    used_order[v] = 1;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (!used_order[to]) {
            used_order[to] = 1;
            dfs_order(to);
        }
    }
    order.push_back(v);
}

int main() {
    std::cin >> n;

    for (int i = 1; i < n; ++i) {
        std::cin >> par[i];
        --par[i];
    }

    for (int mask = 1; mask < (1 << n); ++mask) {
        if (!is_beautiful(mask)) continue;
        for (int i = 0; i < n; ++i) {
            int newmask = (mask | (1 << i));
            if (newmask != mask && is_beautiful(newmask)) {
                g[mask].push_back(newmask);
                g[newmask].push_back(mask);
            }
        }
    }

    dfs_order(1);
    std::reverse(order.begin(), order.end());

    for (int i = 0; i < order.size(); ++i) {
        std::cout << order[i] << std::endl;
    }

    for (int i = 1; i < (1 << n); ++i) {
        if (is_beautiful(i)) {
            std::cout << i << " is beautiful" << std::endl;
        }
    }


    return 0;
}
*/