﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <random>
#include <chrono>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

#define _ << " " <<
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define ff first
#define ss second
#define pb push_back

using namespace std;
//using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const double eps = 1e-12;
const ll INF = 1e18;

bool sieve[50000];
vector<int> prime;
int cnt[601000];

void precalc_sieve() {
    for (int i = 2; i * i < 47000; i++) {
        if (!sieve[i]) {
            for (int j = i * i; j < 47000; j += i) sieve[j] = true;
        }
    }
    for (int i = 2; i < 47000; i++) {
        if (!sieve[i]) prime.pb(i);
    }
}

ll mul_mod(ull x, ull y, ull mod) {
    ll res = 0;
    x %= mod;
    y %= mod;
    while (y != 0) {
        if (y % 2 == 1) {
            res += x;
            if (res >= mod) res -= mod;
        }
        y /= 2;
        x *= 2;
        if (x >= mod) x -= mod;
    }
    return res;
}

ll mul_big_mod(ll x, ll y, ll mod) {
    ll res = 1;
    while (y != 0) {
        if (y % 2 == 1) res = mul_mod(res, x, mod);
        y /= 2; x = mul_mod(x, x, mod);
    }
    return res % mod;
}

bool isPrime(ll p) {
    if (p < 2 || p % 2 == 0) return false;
    if (p == 2)	return true;
    long long q = p - 1, a, t;
    int k = 0;
    bool b;
    while (q % 2 == 0) q /= 2, k++;
    for (int cnt = 0; cnt < 2; cnt++) {
        a = rand() % (p - 4) + 2;
        t = mul_big_mod(a, q, p);
        b = (t == 1) || (t == p - 1);
        for (int i = 1; i < k && !b; i++) {
            t = mul_mod(t, t, p);
            if (t == p - 1) b = true;
        }
        if (!b) return false;
    }
    return true;
}

void small_factorize(ll n, vector<ll>& f) {
    for (int i = 0; i < prime.size() && prime[i] * prime[i] <= n; i++) {
        if (n % prime[i] == 0) {
            while (n % prime[i] == 0) {
                f.pb(prime[i]);
                n /= prime[i];
            }
        }
    }
    if (n > 1) f.pb(n);
}

ll my_gcd(ll x, ll y) {
    if (x < 0) x = -x;
    if (y < 0) y = -y;
    if (x == 0 || y == 0) return x + y;
    ll t;
    while (x % y != 0) {
        t = x;
        x = y;
        y = t % y;
    }
    return y;
}

ll pollard_rho(ll n, ll c) {
    ll x = 2, y = 2, i = 1, k = 2, d;
    while (1) {
        x = mul_mod(x, x, n) + c;
        if (x >= n) x -= n;
        d = my_gcd(x - y, n);
        if (d > 1) return d;
        i++;
        if (i == k) {
            y = x;
            k *= 2;
        }
    }
    return n;
}

void factorize(ll n, vector<ll>& f) {
    if (n == 1) return;
    if (n < 1e9) {
        small_factorize(n, f);
        return;
    }
    if (isPrime(n)) {
        f.pb(n);
        return;
    }
    ll d = n;
    for (int i = 2; d == n; i++) {
        d = pollard_rho(n, i);
    }
    factorize(d, f);
    factorize(n / d, f);
}

ll bp(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) res = res * a % mod;
        a = a * a % mod;
        n >>= 1;
    }
    return res;
}


int main() {
    srand(time(0));
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output_false.txt", "w", stdout); //outs
#endif
    precalc_sieve();
    int a, b, c, n;
    cin >> a >> b >> c >> n;
    for (int i = 0; i < n; i++) {
        ll cur = 1ll * a * i * i + 1ll * b * i + c;
        vector<ll> f;
        map<ll, int> r;
        factorize(cur, f);
        for (auto& i : f) cnt[i]++;
    }
    ll ans = 1;
    for (int i = 1; i <= 600000; i++) {
        if (cnt[i]) {
            cnt[i] -= cnt[i] % 2;
            ans = ans * bp(i, cnt[i]) % mod;
        }
    }
    cout << ans << endl;
    return 0;
}