#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
using namespace std;

template <class T> ostream& operator<<(ostream &O, const vector<T>& v) {for (const T &e: v) O << e << ' '; return O;}
template <class T1, class T2> ostream& operator<<(ostream &O, const pair<T1,T2>& p) {return O << '(' << p.first << ' ' << p.second << ')';}

const int inf = 1e6 + 1;


pair<pair<int,int>, pair<int,int>> balance(pair<int, int> a) {
    return make_pair(make_pair((a.first + 1) / 2, a.second / 2), make_pair(a.first / 2, (a.second + 1) / 2));
}

vector<int> weight(inf);
vector<int> nodes;
vector<pair<int,int>> children(inf);

void solve(int src, pair<int,int> bal, int par) {
    if (bal.first + bal.second == 0) return;

    nodes.emplace_back(src);
    if (children[par].first) {
        children[par].second = src;
    } else {
        children[par].first = src;
    }

    if (bal.first + bal.second == 1) {
        if (bal.first) weight[src] = 1;
        else weight[src] = 2;
        return;
    }





    pair<int, int> left, right;
    int diff = inf;

    //put 1
    if (bal.first) {
        bal.first--;
        auto a = balance(bal).first;
        auto b = balance(bal).second;

        weight[src] = 1;

        left = a;
        right = b;

        diff = abs(a.first + a.second * 2 - b.first - b.second * 2);

        bal.first++;
    }

    //put 2
    if (bal.second) {
        bal.second--;
        auto a = balance(bal).first;
        auto b = balance(bal).second;
        if (diff > abs(a.first + a.second * 2 - b.first - b.second * 2)) {
            left = a;
            right = b;
            weight[src] = 2;
            diff = abs(a.first + a.second * 2 - b.first - b.second * 2);
        }

        bal.second++;
    }

    if (diff > 1) {
        cout << -1;
        exit(0);
    }


    solve(src * 2, left, src);
    solve(src * 2 + 1, right, src);
}

int binarySearch(vector<int> & vec,int x) {
    int start = 0, end = vec.size() - 1, mid;
    while (start <= end) {
        mid = start + (end - start) / 2;
        if (vec[mid] == x) return mid + 1;
        else if (vec[mid] > x) end = mid - 1;
        else start = mid + 1;
    }
    return 0;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int a, b;
    cin >> a >> b;

    solve(1, make_pair(a, b), 0);

    sort(all(nodes));


    for (int i = 0; i < nodes.size(); i++) {
        cout << weight[nodes[i]] << ' ';
        int left = binarySearch(nodes, children[nodes[i]].first), right = binarySearch(nodes, children[nodes[i]].second);
        cout << left << ' ' << right << '\n';
    }
}