#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

void solve() {
    int n;
    cin >> n;
    vector<string> stairs(n);
    for (int i = 0; i < n; i++)
        cin >> stairs[i];
	
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= 8; j++) {
            if (i + j >= n)
                continue;
            int x = 0;
            for (int k = 0; k < 8; k++)
                if (stairs[i][k] == stairs[i + j][k])
                    x++;
            if (j <= x)
                g[i].push_back(i + j);
        }
    }

    vector<char> win(n);
    win[n - 1] = 0;
    for (int v = n - 1; v >= 0; v--) {
        bool loose = 0;
        for (int to : g[v])
            loose |= (win[to]);
        win[v] = !loose;
    }
	
    for (int i = 1; i < n; i++)
        cout << win[i] + 1;
	cout << "1\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
    return 0;
}