#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <climits>
#include <utility>
#include <vector>

using namespace std;

struct Node {
	int w;
	int lch;
	int rch;
};

int index(int j, int lv)
{
	int answer = lv;
	int cr = 2;
	while (j > 0)
	{
		if (j % 2 == 1) answer += lv / cr;
		j /= 2;
	}
	return answer;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int a, b;
	cin >> a >> b;

	if (a < 1)
	{
		cout << -1;
		return 0;
	}

	int temp_b = b, k = 2;
	while (temp_b - k >= 0)
	{
		temp_b -= k;
		k *= 2;
	}

	if (temp_b > a - 1 && b > 0)
	{
		cout << -1;
		return 0;
	}

	vector <Node> tree(a + b);
	
	Node ts = { 1, 0, 0 };
	if (a + b >= 3) ts.rch = 3;
	if (a + b >= 2) ts.lch = 2;
	tree[0] = ts;

	k = 2;
	while (k < a + b) k *= 2;
	k = k / 4;

	int lv = 2, j = 0;
	for (int i = 2; i <= a + b; i++)
	{
		int wc = 1, lch = 0, rch = 0, ci = index(j, lv);
		if (ci - 1 <= b) wc = 2;
		if (i < k) {
			lch = i * 2;
			rch = i * 2 + 1;
		}
		else {
			if (index(j * 2, lv * 2) <= a + b) lch = index(j * 2, lv * 2);
			if (index(j * 2 + 1, lv * 2) <= a + b) rch = index(j * 2 + 1, lv * 2);
		}

		j++;
		if (j >= lv)
		{
			j = 0;
			lv *= 2;
		}

		tree[i - 1] = { wc, lch, rch };
	}

	for (auto i : tree) cout << i.w << " " << i.lch << " " << i.rch << endl;
}