#include <bits/stdc++.h>

using namespace std;

#define MULTITEST

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sqr(a) ((a) * (a))
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++) 
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ld, ld> point;

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &v) {
	out << "[";
	forn(i, sz(v)) {
		if(i) out << ", ";
		out << v[i];
	}
	return out << "]";
}

mt19937 rnd(time(NULL));

const int INF = int(1e9);
const li INF64 = li(1e18);
const int MOD = int(1e9) + 7;
const ld EPS = 1e-9;
const ld PI = acos(-1.0);

const int N = 2 * 1000 * 1000 + 13;
const int M = 5 * 1000 * 1000 + 13;

pt a, b, c;

bool read () {
	if (scanf("%d%d%d%d%d%d", &a.x, &a.y, &b.x, &b.y, &c.x, &c.y) != 6)
		return false;
	return true;
}

struct line{
	li A, B, C;
	line(const pt &a, const pt &b){
		A = a.y - b.y;
		B = b.x - a.x;
		C = -A * a.x - B * a.y;
	}
};

ld dist(const point &a, const point &b){
	return sqrtl(sqr(a.x - b.x) + sqr(a.y - b.y));
}

bool in(const point &p, const point &a, const point &b){
	return fabsl(dist(p, a) + dist(p, b) - dist(a, b)) < EPS;
}

li det(const li &a, const li &b, const li &c, const li &d){
	return a * d - b * c;
}

bool inter(const line &a, const line &b, const pt &c, const pt &d, point &p){
	li D = det(a.A, a.B, b.A, b.B);
	if (D == 0) return false;
	li Dx = det(a.C, a.B, b.C, b.B);
	li Dy = det(a.A, a.C, b.A, b.C);
	p = mp(-Dx / ld(D), -Dy / ld(D));
	if (!in(p, c, d)) return false;
	return true;
}

int fact[M], rfact[M];

int add(int a, int b){
	a += b;
	if (a >= MOD)
		a -= MOD;
	if (a < 0)
		a += MOD;
	return a;
}

int mul(int a, int b){
	return a * li(b) % MOD;
}

int binpow(int a, int b){
	int res = 1;
	while (b){
		if (b & 1)
			res = mul(res, a);
		a = mul(a, a);
		b >>= 1;
	}
	return res;
}

int cnk(int n, int k){
	if (n < 0 || k > n || k < 0) return 0;
	return mul(fact[n], mul(rfact[k], rfact[n - k]));
}

int pref(int n, int k){
	if (k < 0) return 0;
	return cnk(n + k + 1, n + 1);
}

void solve() {
	line ab(a, b), bc(b, c), ca(c, a);
	int ans = 0;
	forn(i, N){
		line L(mp(-i, i), mp(-i + 1, i + 1));
		vector<point> ints;
		point p;
		if (inter(L, ab, a, b, p)) ints.pb(p);
		if (inter(L, bc, b, c, p)) ints.pb(p);
		if (inter(L, ca, c, a, p)) ints.pb(p);
		sort(all(ints));
		ints.resize(unique(all(ints), [](const point &a, const point &b){ return fabsl(a.x - b.x) < EPS && fabsl(a.y - b.y) < EPS; }) - ints.begin());
		if (sz(ints) == 1) ints.pb(ints[0]);
		if (ints.empty()) continue;
		ld ll = ceill(ints[0].x);
		ld rr = floorl(ints[1].x);
		int l = ll;
		if (fabsl(ll + 1 - l) < fabsl(ll - l)) ++l;
		if (fabsl(ll - 1 - l) < fabsl(ll - l)) --l;
		int r = rr;
		if (fabsl(rr + 1 - r) < fabsl(rr - r)) ++r;
		if (fabsl(rr - 1 - r) < fabsl(rr - r)) --r;
		l += i;
		r += i;
		if (l > r) continue;
		//cerr << i << " " << l << " " << r << " " << pref(i, l - 1) << " " << pref(i, r) << endl;
		ans = add(ans, pref(i, r));
		ans = add(ans, -pref(i, l - 1));
	}
	printf("%d\n", ans);
}

void precalc(){
	fact[0] = 1;
	fore(i, 1, M) fact[i] = mul(fact[i - 1], i);
	rfact[M - 1] = binpow(fact[M - 1], MOD - 2);
	for (int i = M - 2; i >= 0; --i)
		rfact[i] = mul(rfact[i + 1], i + 1);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	
	int tt = clock();
	
#endif
	
	cerr.precision(15);
	cout.precision(15);
	cerr << fixed;
	cout << fixed;

	precalc();
#ifdef MULTITEST
	int tc;
	scanf("%d", &tc);
	while(tc--){
		read();
#else
	while(read()) {	
#endif
		solve();
		
#ifdef _DEBUG
	cerr << "TIME = " << clock() - tt << endl;
	tt = clock();
#endif

	}
}