#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define MULTITEST

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sqr(a) ((a) * (a))
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++) 
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &v) {
	out << "[";
	forn(i, sz(v)) {
		if(i) out << ", ";
		out << v[i];
	}
	return out << "]";
}

mt19937 rnd(time(NULL));

const int INF = int(1e9);
const li INF64 = li(1e18);
const int MOD = int(1e9) + 7;
const ld EPS = 1e-9;
const ld PI = acos(-1.0);

typedef tree<
pt,
null_type,
less<pt>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

const int N = 200 * 1000 + 13;

int n, m;
int l[N], r[N], x[N];
pt q[N];

bool read () {
	if (scanf("%d", &n) != 1)
		return false;
	forn(i, n){
		scanf("%d%d%d", &l[i], &r[i], &x[i]);
		--l[i];
		--r[i];
	}
	scanf("%d", &m);
	forn(i, m){
		scanf("%d%d", &q[i].x, &q[i].y);
	}
	return true;
}

pt seg[N];
int p[N];

void dfs(int v){
	seg[v] = mp(x[v], x[v]);
	for (int u : {l[v], r[v]}) if (u != -1){
		p[u] = v;
		dfs(u);
		seg[v].x = min(seg[v].x, seg[u].x);
		seg[v].y = max(seg[v].y, seg[u].y);
	}
}

bool inter(int a, int b, int c, int d){
	return max(a, c) <= min(b, d);
}

bool in(int a, int b, int c, int d){
	return a <= c && d <= b;
}

int ans[N];

void countl(){
	vector<int> rs;
	forn(i, n) rs.pb(seg[i].y);
	sort(all(rs));
	forn(i, m) ans[i] -= lower_bound(all(rs), q[i].x) - rs.begin();
}

void countr(){
	vector<int> ls;
	forn(i, n) ls.pb(seg[i].x);
	sort(all(ls));
	forn(i, m) ans[i] -= ls.end() - upper_bound(all(ls), q[i].y);
}

void countin(){
	vector<pair<pt, int>> qs;
	forn(i, n) qs.pb(mp(mp(seg[i].y, 0), i));
	forn(i, m) qs.pb(mp(mp(q[i].y, 1), i));
	sort(all(qs));
	ordered_set X;
	forn(i, sz(qs)){
		int j = qs[i].y;
		if (qs[i].x.y == 0)
			X.insert(mp(seg[j].x, j));
		else
			ans[j] -= sz(X) - X.order_of_key(mp(q[j].x, -INF));
	}
}

void solve() {
	p[0] = -1;
	dfs(0);
	forn(i, m) ans[i] = n;
	countl();
	countr();
	countin();
	forn(i, m) printf("%d\n", ans[i] * 2 + 1);
	//forn(i, m) cerr << ans[i] << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	
	int tt = clock();
	
#endif
	
	cerr.precision(15);
	cout.precision(15);
	cerr << fixed;
	cout << fixed;

#ifdef MULTITEST
	int tc;
	scanf("%d", &tc);
	while(tc--){
		read();
#else
	while(read()) {	
#endif
		solve();
		
#ifdef _DEBUG
	cerr << "TIME = " << clock() - tt << endl;
	tt = clock();
#endif

	}
}