#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <fstream>
#include <stack>
#include <cstring>
#include <math.h>
#include <queue>
#include <list>
#include <stdlib.h>

using namespace std;


typedef int intor;
#define int long long
#define ll long long
#define ld long double
#define vi vector<int>
#define vd vector<double>
#define pii pair<int,int>
#define pdd Pair<double, double>

#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

#ifdef int
#define INF (1000ll*1000ll*1000ll*1000ll*1000ll*1000ll)
#else
#define INF (1000*1000*10)
#endif
#define LL_INF (1000ll*1000ll*1000ll*1000ll*1000ll*1000ll)
#define EPS 1e-10

#define NMAX (50+10)
#define MMAX (0x200)
#define MOD ((long long)1e9 +7ll)

double d[NMAX+1], h[NMAX];
bool up_av[NMAX][NMAX];
pair<double, double> up[NMAX][NMAX];
bool down_av[NMAX][NMAX];
pair<double, double> down[NMAX][NMAX];
intor main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.precision(10);
	
	int n;
	double L;
	cin >> n >> L;
	d[0] = 0;
	for (int i = 1; i < n+1; i++)
	{
		cin >> d[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> h[i];
	}

	double path = 0;
	double cur_x = d[0], cur_y = h[0];

	//fill matrices
	//up proc
	for (int i = 0; i < n-1; i++)
	{
		for (int j = i + 1; j < n; j++)
		{

			up_av[i][j] = false;
			if (h[j] < h[i]) continue;
			double stj_x = d[j];
			double stj_y = h[j];

			double sti_x = d[i];
			double sti_y = h[i];

			double min_tg = INF;
		
			for (int k = i + 1; k < j; k++)
			{
				double stk_x = d[k];
				double stk_y = h[k];

				min_tg = min(min_tg, (stj_y - stk_y) / (stj_x - stk_x));

			}
			if (min_tg < 0)continue;

			double dy = stj_y - sti_y;
			double dx = stj_x - sti_x;
			double cur_tg = (dy) / (dx);
			if (min_tg < cur_tg)
			{
				continue;
			}


			double dx0 = max(dy / (min_tg), d[j] - d[i + 1]);
			double L0 = sqrt(dy * dy + dx0 * dx0);
			if (L0 > L) continue;
			up[i][j].second = stj_x - dx0;

			up[i][j].first = max(sti_x, stj_x - sqrt(L * L - dy * dy));

			up_av[i][j] = true;
		}
	}
	
	//down proc
	for (int i = 0; i < n - 1; i++)
	{
		for (int j = i + 1; j < n; j++)
		{

			down_av[i][j] = false;



			double eni_x = d[i+1];
			double eni_y = h[i];

			double enj_x = d[j + 1];
			double enj_y = h[j];

			double min_tg = INF;

			for (int k = i + 1; k < j; k++)
			{
				double enk_x = d[k + 1];
				double enk_y = h[k];

				min_tg = min(min_tg, (eni_y - enk_y) / (enk_x - eni_x));
			}

			double dy = eni_y - enj_y;
			double dx = enj_x - eni_x;
			double cur_tg = (dy) / (dx);
			if (min_tg < cur_tg)
			{
				continue;
			}
			if (min_tg < 0) continue;


			double dx0 = max(dy / (min_tg), d[j]-d[i+1]);
			double L0 = sqrt(dy * dy + dx0 * dx0);
			if (L0 > L) continue;

			down[i][j].first = eni_x + dx0;
			down[i][j].second = min(enj_x, eni_x + sqrt(L * L - dy * dy));

			down_av[i][j] = true;

		}
	}

	double st_path[NMAX];
	double en_path[NMAX];
	for (int i = 0; i < n; i++)
	{
		st_path[i] = LL_INF;
		en_path[i] = LL_INF;
	}

	st_path[0] = 0;

	for (int i = 0; i < n; i++)
	{
		//start proc
		for (int j = i + 1; j < n; j++)//proc jump up
		{
			if (!up_av[i][j]) continue;

			double l_walk = up[i][j].first - d[i];
			double dy = h[j] - h[i];
			double dx = d[j] - up[i][j].first;
			st_path[j] = min(st_path[j], st_path[i] + (l_walk)+sqrt(dx * dx + dy * dy));
		}

		//proc end
		en_path[i] = st_path[i] + (d[i + 1] - d[i]);
		for (int j = i + 1; j < n; j++) // proc jump down to the end
		{
			if (!down_av[i][j]) continue;

			double l_walk = d[j+1] - down[i][j].second;
			double dy = h[i] - h[j];
			double dx = down[i][j].second - d[i + 1];
			en_path[j] = min(en_path[j], en_path[i] + l_walk + sqrt(dx * dx + dy * dy));
		}

		//proc double jump
		for (int j = i + 1; j < n; j++)
		{
			for (int k = j + 1; k < n; k++)
			{
				if (!down_av[i][j]) continue;
				if (!up_av[j][k])continue;


				double dy1 = h[i] - h[j];
				double dy2 = h[k] - h[j];
				//intersect
				if (down[i][j].second > up[j][k].first && up[j][k].second > down[i][j].first)
				{
					double st = max(down[i][j].first, up[j][k].first);
					double en = min(down[i][j].second, up[j][k].second);

					double tot_dx = d[k] - d[i + 1];

					double opt_dx1 = tot_dx * dy1 / (dy1 + dy2);
					double opt_x = d[i + 1] + opt_dx1;
					if (opt_x > st && opt_x < en)
					{
						double opt_dx2 = tot_dx - opt_dx1;
						double j1 = sqrt(dy1 * dy1 + opt_dx1 * opt_dx1);
						double j2 = sqrt(dy2 * dy2 + opt_dx2 * opt_dx2);
						st_path[k] = min(st_path[k], en_path[i] + j1 + j2);
					}
					else
					{
						if (opt_x < st)
						{
							double dx1 = st - d[i + 1];
							double dx2 = tot_dx - dx1;
							double j1 = sqrt(dy1 * dy1 + dx1 * dx1);
							double j2 = sqrt(dy2 * dy2 + dx2 * dx2);
							st_path[k] = min(st_path[k], en_path[i] + j1 + j2);
						}
						else//>end
						{
							double dx1 = en - d[i + 1];
							double dx2 = tot_dx - dx1;
							double j1 = sqrt(dy1 * dy1 + dx1 * dx1);
							double j2 = sqrt(dy2 * dy2 + dx2 * dx2);
							st_path[k] = min(st_path[k], en_path[i] + j1 + j2);
						}
					}

				}
				//not intersect
				else
				{
					//go forw
					if (up[j][k].first > down[i][j].second)
					{
						double l_walk = up[j][k].first - down[i][j].second;
						double dx1 = down[i][j].second - d[i + 1];
						double dx2 = d[k] - up[j][k].first;
						double j1 = sqrt(dy1 * dy1 + dx1 * dx1);
						double j2 = sqrt(dy2 * dy2 + dx2 * dx2);
						st_path[k] = min(st_path[k], en_path[i] + l_walk + j1 + j2);
					}
					//go back
					else
					{
						double l_walk = down[i][j].first - up[j][j].second;
						double dx1 = down[i][j].first - d[i + 1];
						double dx2 = d[k] - up[j][k].second;
						double j1 = sqrt(dy1 * dy1 + dx1 * dx1);
						double j2 = sqrt(dy2 * dy2 + dx2 * dx2);
						st_path[k] = min(st_path[k], en_path[i] + l_walk + j1 + j2);
					}
				}


			}
		}
		
	}
	if (en_path[n - 1] >= INF)
	{
		cout << -1;
		return 0;
	}
	cout << en_path[n - 1];

	return 0;
}

/*
2 3 3 2
.**
**.
*/