﻿#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifndef DEBUG
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#endif

#define int long long
#define double long double

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename S, typename T>
using ordered_map = tree<S, T, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const bool MULTI_TEST = false;


struct Node {
    int s;
    int val = -1;
    int l = -1, r = -1;
};
vector<Node> nodes;

int make_node(int s) {
    if (s == 0) {
        return -1;
    }
    nodes.push_back({s});
    return nodes.size() - 1;
}

int make_tree(int a, int b) {
    int v = make_node(a + 2 * b);
    queue<int> q;
    q.push(v);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (v == -1) {
            continue;
        }

        if (b > 0 && nodes[v].s >= 2) {
            b--;
            nodes[v].val = 2;
        } else if (nodes[v].s > 0) {
            if (a == 0) {
                return -1;
            }
            a--;
            nodes[v].val = 1;
        }

        int t = (nodes[v].s - nodes[v].val) / 2;
        int l = nodes[v].l = make_node(t);
        int r = nodes[v].r = make_node(nodes[v].s - nodes[v].val - t);
        q.push(l);
        q.push(r);
    }
    return v;
}

void print(int v) {
    if (v == -1) {
        return;
    }
    cout << nodes[v].val << ' ' << nodes[v].l + 1 << ' ' << nodes[v].r + 1 << '\n';
    print(nodes[v].l);
    print(nodes[v].r);
}

void solve() {
    int a, b;
    cin >> a >> b;
    int root = make_tree(a, b);
    if (root != -1) {
        print(root);
    } else {
        cout << -1;
    }
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    if (MULTI_TEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }

    return 0;
}


