#include <vector>
#include <bitset>
#include <iostream>

#define MULTI_TEST false
#define int long long
#define double long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")

#define all(x) x.begin(), x.end()

using namespace std;

const int N = 300002;

void solve() {
    int n;
    cin >> n;
    bitset<N> b[n];
    bitset<8> v[n];
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++){
        string s;
        cin >> s;
        for (int j = 0; j < 8; j++){
            if (s[j] == 'R')
                v[i].set(j);
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j <= i + 8 && j < n; j++){
            auto x = v[i] ^ v[j];
            auto k = 8 - x.count();
            if (j - i <= k)
                g[i].push_back(j);
        }
    }
    bitset<N> c;
    for (int i = n - 1; i >= 0; i--){
        c.set(i);
        b[i] = c;
        for (auto x: g[i])
            b[i] &= b[x];
        b[i].flip();
    }
    for (int i = 0; i < n;i++){
        cout << 2 - b[0][i];
    }
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    if (MULTI_TEST)
        cin >> t;
    while (t--)
        solve();

    return 0;
}

