#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

const int INF = 2e9;

struct node {
	int l, r, min, max, key;
	node() : l(0), r(0), min(0), max(0), key(0) {}
};

vector <node> val;

int getMax(int v) {
	if (v == 0) return -INF;
	val[v].max = max(getMax(val[v].l), max(val[v].key, getMax(val[v].r)));
	return val[v].max;
}

int getMin(int v) {
	if (v == 0) return INF;
	val[v].min = min(getMin(val[v].l), min(val[v].key, getMin(val[v].r)));
	return val[v].min;
}

int NumCall(int v, int l, int r) {
	if (v == 0) return 1;
	if (l <= val[v].min && val[v].max <= r) return 1;
	if (val[v].max < l || r < val[v].min) return 1;
	return NumCall(val[v].l, l, r) + NumCall(val[v].r, l, r) + 1;
}

int main() {

	//fstream cin("input.txt");
	//ofstream cout("output.txt");

	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int n, q; cin >> n;
	val.resize(n + 1);

	for (int i = 1; i <= n; i++) {
		int a, b, c; cin >> a >> b >> c;
		val[i].l = a, val[i].r = b, val[i].key = c;
	}

	getMax(1);
	getMin(1);

	cin >> q;

	for (int i = 0; i < q; i++) {
		int l, r; cin >> l >> r;
		cout << NumCall(1, l, r) << '\n';
	}




}