#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define y1 yy1

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

const int MOD = 1e9 + 7;

int sum(int a, int b) {
    if (a + b >= MOD) {
        return a + b - MOD;
    }
    return a + b;
}

int sub(int a, int b) {
    if (a < b) {
        return a - b + MOD;
    }
    return a - b;
}

int mul(int a, int b) {
    return 1LL * a * b % MOD;
}

int power(int a, int k) {
    if (k == 0) {
        return 1;
    }
    int t = power(a, k >> 1);
    t = mul(t, t);
    if (k & 1) {
        t = mul(t, a);
    }
    return t;
}

const int X = 4e6 + 239;

int fact[X], inv[X];

int getC(int n, int k) {
    if (n < k) {
        return 0;
    }
    return mul(fact[n], mul(inv[k], inv[n - k]));
}

int getsum(int k, int l, int r) {
    return sub(getC(r + 1, k + 1), getC(l, k + 1));
}

void move(int& x, int& y) {
    int a = x + y;
    int b = y - x;
    x = a;
    y = b;
}

const int BIG = 1e9 + 239;

ll mydiv(ll a, ll b) {
    if (a >= 0 || a % b == 0) {
        return a / b;
    }
    return (a / b) - 1;
}

int inter_up(int x1, int y1, int x2, int y2, int x) {
    if (x < x1 || x > x2 || x1 == x2) {
        return -BIG;
    }
    ll s = (ll)y1 * (ll)(x2 - x) + (ll)y2 * (ll)(x - x1) + (ll)(x2 - x1) - 1;
    return mydiv(s, (ll)(x2 - x1));
}

int inter_down(int x1, int y1, int x2, int y2, int x) {
    if (x < x1 || x > x2 || x1 == x2) {
        return BIG;
    }
    ll s = (ll)y1 * (ll)(x2 - x) + (ll)y2 * (ll)(x - x1);
    return mydiv(s, (ll)(x2 - x1));
}

int x1, y1, x2, y2, x3, y3;

pair<int, int> inter(int x) {
    if (x < x1 || x > x3) {
        return make_pair(1, 0);
    }
    if ((ll)(x3 - x1) * (ll)y2 <= (ll)y1 * (ll)(x3 - x2) + (ll)y3 * (ll)(x2 - x1)) {
        int t1 = inter_down(x1, y1, x3, y3, x);
        int t2 = inter_up(x1, y1, x2, y2, x);
        int t3 = inter_up(x2, y2, x3, y3, x);
        return make_pair(max(t2, t3), t1);
    }
    int t1 = inter_up(x1, y1, x3, y3, x);
    int t2 = inter_down(x1, y1, x2, y2, x);
    int t3 = inter_down(x2, y2, x3, y3, x);
    return make_pair(t1, min(t2, t3));
}

void solve() {
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    move(x1, y1);
    move(x2, y2);
    move(x3, y3);
    if (x1 > x2) {
        swap(x1, x2);
        swap(y1, y2);
    }
    if (x1 > x3) {
        swap(x1, x3);
        swap(y1, y3);
    }
    if (x2 > x3) {
        swap(x2, x3);
        swap(y2, y3);
    }
    assert(x1 <= x2);
    assert(x2 <= x3);
    //cerr << x1 << " " << y1 << " " << x2 << " " << y2 << " " << x3 << " " << y3 << "\n";
    int to = max(x1, x2);
    to = max(to, x3);
    int ans = 0;
    for (int i = 0; i <= to; i += 2) {
        pair<int, int> t = inter(i);
        if (t.first > t.second) {
            continue;
        }
        t.first = max(t.first, 0);
        t.first = mydiv(t.first + 1, 2LL);
        t.second = mydiv(t.second, 2LL);
        if (t.first <= t.second) {
            ans = sum(ans, getsum(i / 2, t.first + (i / 2), t.second + (i / 2)));
        }
    }
    cout << ans << "\n";
}

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    fact[0] = 1;
    for (int i = 1; i < X; i++) {
        fact[i] = mul(fact[i - 1], i);
    }
    inv[X - 1] = power(fact[X - 1], MOD - 2);
    for (int i = X - 2; i >= 0; i--) {
        inv[i] = mul(inv[i + 1], i + 1);
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
