/*

Code for problem O by cookiedoth
Generated 13 Dec 2020 at 02.46 PM


▅███████ ]▄▄▄▄▄▄▄ 
█████████▅▄▃ 
Il████████████████] 
◥⊙▲⊙▲⊙▲⊙▲⊙▲⊙▲⊙◤

^_^
~_^
=_=

*/

#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <ctime>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <complex>
#include <cassert>
#include <random>
#include <cstring>
#include <numeric>
#include <random>
#include <utility>
#include <tuple>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << #a << " = " << a << endl
#define forn(i, n) for (int i = 0; i < n; ++i)
#define length(a) (int)a.size()

using namespace std;

template<class T> int chkmax(T &a, T b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, T b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream& out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int MAX_N = 75;
int n, m, c[MAX_N][MAX_N], d[MAX_N][MAX_N], a[MAX_N];

void read() {
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> c[i][j];
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> d[i][j];
		}
	}
}

const int INF = 1e9;
int pos[MAX_N], opt_pos[MAX_N], best_tot = INF;

void random_assign() {
	for (int i = 0; i < n; ++i) {
		pos[i] = rand() % m;
	}
}

int get_dist(int chel) {
	int res = 0;
	for (int i = 0; i < n; ++i) {
		res += abs(a[pos[chel]] - a[pos[i]]) * d[chel][i];
	}
	for (int i = 0; i < m; ++i) {
		res += abs(a[pos[chel]] - a[i]) * c[chel][i];
	}
	return res;
}

ld t0 = clock();

ld watch() {
	return ((ld)clock() - t0) / CLOCKS_PER_SEC;
}

int get_tot() {
	int tot = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			tot += d[i][j] * abs(a[pos[i]] - a[pos[j]]);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			tot += c[i][j] * abs(a[pos[i]] - a[j]);
		}
	}
	// cerr << "tot = " << tot << '\n';
	if (chkmin(best_tot, tot)) {
		copy(pos, pos + n, opt_pos);
	}
	return tot;
}

void local_optimizations() {
	get_tot();
	while (watch() < 0.001) {
		int id = rand() % n;
		int new_pos = rand() % m;
		int old_dist = get_dist(id);
		int old_pos = pos[id];
		pos[id] = new_pos;
		int new_dist = get_dist(id);
		if (new_dist > old_dist) {
			pos[id] = old_pos;
		}
		if (new_dist < old_dist) {
			get_tot();
			// cerr << "improved\n";
			// cerr << "get_tot = " << get_tot() << '\n';
		}
	}
}

void go() {
	random_assign();
	local_optimizations();
}

void print_ans() {
	copy(opt_pos, opt_pos + n, pos);
	int tot = get_tot();
	cout << tot << '\n';
	for (int i = 0; i < n; ++i) {
		cout << a[pos[i]] << ' ';
	}
	cout << '\n';
}

signed main() {
	fast_io();
	read();
	for (int it = 0; it < 1800; ++it) {
		go();
	}
	print_ans();
}
