#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define all(x) begin(x), end(x)
#define debug(x) cerr << #x << " = " << x << endl;
#define len(a) (int)(a.size())

using ll = long long;
using ld = long double;
using namespace std;

ll MOD = 1e9 + 7;

ll powm(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) {
        return a * powm(a, n - 1) % MOD;
    }
    ll b = powm(a, n / 2);
    return b * b % MOD;
}

const ll MAX = 2e6;

ll fact[MAX];
ll rfact[MAX];

void precalc() {
    fact[0] = 1;
    rfact[0] = powm(fact[0], MOD - 2);
    for (int i = 1; i < MAX; i++) {
        fact[i] = fact[i - 1] * i % MOD;
        rfact[i] = powm(fact[i], MOD - 2);
    }
}


struct point {
    ll x, y;
};

point operator-(point a, point b) {
    return {a.x - b.x, a.y - b.y};
}
ll dot(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

point a, b, c;

bool in(point x) {
    ll s = dot(c - a, b - a);
    ll s1 = dot(c - x, b - x);
    ll s2 = dot(b - x, a - x);
    ll s3 = dot(a - x, c - x);
    return abs(s) == abs(s1) + abs(s2) + abs(s3);
}

ll C(ll n, ll k) {
    if (k > n) return 0;
    return fact[n] * rfact[k] % MOD * rfact[n - k] % MOD;
}

ll INF = 1e9;

point bad = {-MAX - 1, -MAX - 1};

pair<ll, ll> fnd(point a, point b, ll d) {
    ll d0 = dot(a - b, point{-d, d} - b);
    ll dm = dot(a - b, point{-d + MAX, d + MAX} - b);
    if (d0 > 0 && dm > 0) {
        return {0, 0};
    }
    if (d0 < 0 && dm < 0) {
        return {0, 0};
    }
    bool f;
    if (d0 > 0) f = 0;
    else f = 1;
    ll l = 0, r = MAX;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        ll dd = dot(a - b, point{-d + m, d + m} - b);
        if ((dd > 0 && !f) || (dd < 0 && f)) {
            l = m;
        } else {
            r = m;
        }
    }
    return {l, r};
}

void solve() {
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    ll res = 0;
    for (int d = 0; d < MAX / 3 * 2; d++) {
        ll mn = INF;
        ll mx = -INF;
        auto p1 = fnd(a, b, d);
        auto p2 = fnd(b, c, d);
        auto p3 = fnd(c, a, d);
        if (a.x - b.x != a.y - b.y)
            if (in({p1.first - d, p1.first + d})) {
                mn = min(p1.first, mn);
                mx = max(p1.first, mx);
            }
        if (b.x - c.x != b.y - c.y)
            if (in({p2.first - d, p2.first + d})) {
                mn = min(p2.first, mn);
                mx = max(p2.first, mx);
            }
        if (c.x - a.x != c.y - a.y)    
            if (in({p3.first - d, p3.first + d})) {
                mn = min(p3.first, mn);
                mx = max(p3.first, mx);
            }
        if (a.x - b.x != a.y - b.y)
            if (in({p1.second - d, p1.second + d})) {
                mn = min(p1.second, mn);
                mx = max(p1.second, mx);
            }
        if (b.x - c.x != b.y - c.y)
            if (in({p2.second - d, p2.second + d})) {
                mn = min(p2.second, mn);
                mx = max(p2.second, mx);
            }
        if (c.x - a.x != c.y - a.y)
            if (in({p3.second - d, p3.second + d})) {
                mn = min(p3.second, mn);
                mx = max(p3.second, mx);
            }
        
        if (mn != INF && mx != -INF) {
            res += C(mx+d+1, d+1);
            res %= MOD;
            res += MOD;
            res -= C(mn+d, d+1);
            res %= MOD;
        }
    }
    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(30);
    precalc();
    int n; cin >> n;
    while (n--)
        solve();
}