#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <iostream>
#include <limits>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>
#include <queue>

#define CHECK_IMPL1(cond)                \
    if (!(cond)) {                       \
      DEBUG("expected cond: " << #cond); \
      assert(cond);                      \
    }

#define CHECK_IMPL2(cond, message)                                              \
    if (!(cond)) {                                                              \
      DEBUG("expected cond: " << #cond << " failed with message: " << message); \
      assert(cond);                                                             \
    }

#define CHECK_IMPL(_1, _2, NAME, ...) NAME
#define CHECK(...) CHECK_IMPL(__VA_ARGS__, CHECK_IMPL2, CHECK_IMPL1, CHECK_IMPL0)(__VA_ARGS__)

#ifdef __APPLE__
#define DEBUG(message) std::cerr << message << std::endl;
#else
#define DEBUG(message)
#endif

void solve() {
  int n;
  std::cin >> n;
  int best = -1;
  int min = std::numeric_limits<int>::max();
  for (int i = 0; i < n; ++i) {
    int p;
    std::string s;
    std::cin >> p >> s;
    std::vector<int> cnt(10);
    for (auto c : s) {
      ++cnt[c - '0'];
    }
    if (cnt[0] >= 1 && cnt[2] >= 2 && cnt[1] >= 1) {
      if (best == -1 || p < min) {
        best = i;
      }
    }
  }
  std::cout << best + 1 << '\n';
}

int main() {
#ifdef __APPLE__
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
#endif
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  int t = 1;
  //std::cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
