#include <iostream>
#include <map>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <random>
#include <time.h>
#include <string>
#include <cstring>
#include <set>
#include <cmath>
#include <cassert>

using namespace std;

const int N = 21;

string s1, s2;
vector<char> vv;
vector<int> distr;
int distro[256];
char rev[10];
set<int> unused_core;

bool nxt() {
    int n = vv.size();
    set<int> unused = unused_core;
    for (int i = 0; i < n; ++i) {
        unused.erase(distr[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        auto it = unused.upper_bound(distr[i]);
        if (it == unused.end()) {
            unused.insert(distr[i]);
            continue;
        }
        unused.insert(distr[i]);
        distr[i] = *it;
        for (int j = i + 1; j < n; ++j) {
            unused.insert(distr[j]);
        }
        for (int j = i + 1; j < n; ++j) {
            auto it2 = unused.begin();
            distr[j] = *it2;
            unused.erase(it2);
        }
        return true;
    }
    return false;
}

map<string, int> masks;
vector<pair<string, int>> msks[20];

void eval() {
    for (int i = 0; i < vv.size(); ++i) {
        distro[vv[i]] = distr[i];
    }
    if (distro[s1[0]] == 0 || distro[s2[0]] == 0) {
        return;
    }
    for (int i = 0; i < 10; ++i) {
        rev[i] = '?';
    }
    for (int i = 0; i < vv.size(); ++i) {
        rev[distr[i]] = vv[i];
    }
    int r1 = 0, r2 = 0;
    for (auto c : s1) {
        r1 = (r1 * 10 + distro[c]);
    }
    for (auto c : s2) {
        r2 = (r2 * 10 + distro[c]);
    }
    int ll = r1 + r2;
    string s;
    char grp = '0';
    while (ll > 0) {
        if (rev[ll % 10] == '?') {
            rev[ll % 10] = (grp++);
        }
        s.push_back(rev[ll % 10]);
        ll /= 10;
    }
    reverse(s.begin(), s.end());
    masks[s]++;
}

char mapping[256];
bool in_s1s2[256];

bool matches_mask(string word, const string& mask) {
    if (word.length() != mask.length()) {
        return false;
    }
    memset(mapping, 0, sizeof(mapping));

    for (int i = 0; i < word.length(); ++i) {
        if (mask[i] >= 'A' && mask[i] <= 'Z') {
            if (mask[i] != word[i]) {
                return false;
            } else {
                mapping[word[i]] = word[i];
            }
        }
    }
    for (int i = 0; i < word.length(); ++i) {
        char c = word[i];
        if (in_s1s2[c] && mask[i] != c) {
            return false;
        }
    }
    char grp = '0';
    for (int i = word.length() - 1; i >= 0; --i) {
        if (mapping[word[i]] == 0) {
            mapping[word[i]] = grp++;
        }
        word[i] = mapping[word[i]];
    }
    return word == mask;
}

int main() {
#ifdef LOCAL_ENV
    freopen("a.in", "r", stdin);
#endif
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> s1 >> s2;
    for (auto c : s1) {
        vv.push_back(c);
        in_s1s2[c] = 1;
    }
    for (auto c : s2) {
        vv.push_back(c);
        in_s1s2[c] = 1;
    }
    sort(vv.begin(), vv.end());
    vv.resize(unique(vv.begin(), vv.end()) - vv.begin());
    for (int i = 0; i < vv.size(); ++i) {
        distr.push_back(i);
    }
    for (int i = 0; i < 10; ++i) {
        unused_core.insert(i);
    }
    while (true) {
        eval();
        if (!nxt()) {
            break;
        }
    }
    for (auto x : masks) {
        msks[x.first.length()].emplace_back(x);
    }
    vector <string> result;
    int q;
    cin >> q;
    while (q--) {
        string word;
        cin >> word;
        int cnt = 0;
        for (auto& lr : msks[word.length()]) {
            auto& mask = lr.first;
            if (matches_mask(word, mask)) {
                cnt += lr.second;
                if (cnt > 1) {
                    break;
                }
            }
        }
        if (cnt == 1) {
            result.push_back(word);
        }
    }
    cout << result.size() << "\n";
    for (auto x : result) {
        cout << x << "\n";
    }
    return 0;
}