#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cstring>
#include <iomanip>
using namespace std;

#define int long long
#define double long double
#define mp make_pair
#define debug(x) cerr << #x << ": " << x << '\n';
#define fi first
#define se second
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;
 
void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 3e6 + 10;
const int mod = 1e9 + 7;

int fact[N], rfact[N];

int mult(int a, int b) {
	return a * b % mod;
}

int mult(int a, int b, int c) {
	return mult(mult(a, b), c);
}

int binpow(int a, int p) {
	if (p == 0) return 1;
	if (p & 1) return mult(a, binpow(a, p - 1));
	return binpow(mult(a, a), p / 2);
}

int rev(int x) {
	return binpow(x, mod - 2);
}

int C(int n, int k) {
	return mult(fact[n], rfact[k], rfact[n - k]);
}

int add(int a, int b) {
	a += b;
	if (a >= mod) return a - mod;
	return a;
}

int sub(int a, int b) {
	a -= b;
	if (a < 0) return a + mod;
	return a;
}

struct point {
	int x, y;

	void scan() {
		cin >> x >> y;
	}
};

const double inf = -1e9;
const double INF = -1e10;

double inter(point a, point b, int m) {
	int A = a.y - b.y;
	int B = b.x - a.x;
	int C = -A * a.x - B * a.y;
	if (A + B == 0) return INF;
	double x = (-C - B * m) / (double)(A + B);
	double y = x + m;
	int lx = a.x, rx = b.x, ly = a.y, ry = b.y;
	if (lx > rx) swap(lx, rx);
	if (ly > ry) swap(ly, ry);
	if (x < lx || x > rx || y < ly || y > ry) return INF;
	return x;
}

void solve() {
	point a, b, c;
	a.scan(), b.scan(), c.scan();
	int ans = 0;
	for (int i = 0; i <= 1e6; i++) {
		vector<double> ints;
		double x = inter(a, b, 2 * i);
		if (x > inf) ints.push_back(x);
		x = inter(a, c, 2 * i);
		//debug(x)
		if (x > inf) ints.push_back(x);
		x = inter(b, c, 2 * i);
		if (x > inf) ints.push_back(x);
		//debug(i << ' ' << ints.size())
		if (ints.size() == 1 || ints.size() > 2) exit(-1);
		if (ints.size() == 2) {
			if (ints[0] > ints[1]) swap(ints[0], ints[1]);
			int l = ceil(ints[0]);
			int r = floor(ints[1]);
			//debug(l << ' ' << r)
			l = max(l, -i);
			if (l > r) continue;
			ans = add(ans, C(r + 2 * i + 1, i + 1));
			if (l > -i) {
				ans = sub(ans, C(l + 2 * i, i + 1));
			}
		}
	}
	cout << ans << '\n';
}

signed main() {
	fast();
	fact[0] = 1;
	for (int i = 1; i < N; i++) {
		fact[i] = mult(fact[i - 1], i); 
	}
	rfact[N - 1] = rev(fact[N - 1]);
	for (int i = N - 2; i >= 0; i--) {
		rfact[i] = mult(rfact[i + 1], i + 1);
	}
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}