#include <iostream>
#include <vector>
#include <map>
#include <bitset>
#include <algorithm>
#include <functional>
#include <random>

using std::cin;
using std::cout;
using std::vector;
using ll = long long;
using ull = unsigned long long;
using pii = std::pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;
#define all(x) (x).begin(), (x).end()
#define isz(x) int((x).size())
#define forx(x, n) for(int x = 0; x < n; ++x)
#define range(x, a, b) for(int x = a; x <= b; ++x)

ll gcd(ll a, ll b, ll & x, ll & y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	ll x1, y1;
	ll d = gcd(b % a, a, x1, y1);
	x = y1 - 1LL * (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution(ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
	g = gcd(a < 0 ? -a : a, b < 0 ? -b : b, x0, y0);
	if (c % g != 0)
		return false;
	x0 = 1LL * x0 * (c / g);
	y0 = 1LL * y0 * (c / g);
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}

const auto ready = []()
{
	cin.tie(0);
	cout.tie(0);
	std::ios_base::sync_with_stdio(false);
	return true;
}();

char int_to_char(int x)
{
	if (x < 10) return char(int('0') + x);
	else return char(int('A') + x - 10);
}

int char_to_int(char x)
{
	if (x >= 'A' && x <= 'Z') return int(int(x) + 10 - int('A'));
	else return int(int(x) - int('0'));
}

int main()
{
	int n; cin >> n;
	vvi adj(n + 1);
	for (int u = 2; u <= n; ++u)
	{
		int pu; cin >> pu;
		adj[u].push_back(pu);
		adj[pu].push_back(u);
	}
	vector<ll> dp(n + 1, 0);
	vector<std::string> ops(n + 1, "");
	std::function<void(int, int)> dfs = [&](int u, int from)
	{
		ll cur = 0LL;
		int c = -1;
		for (auto &v : adj[u]) if (v != from) dfs(v, u);
		for (auto &v : adj[u]) if (v != from) cur = dp[v] + 1, c = v;
		for (auto &v : adj[u])
		{
			if (v != from && v != c)
			{
				ll tmp = dp[v] + 2;
				cur *= tmp;
				cur += (tmp - 1);
			}
		}
		std::string cur_str = "";
		if(c != -1) cur_str = std::string(1, int_to_char(c)) + ops[c];
		for (auto &v : adj[u])
		{
			if (v != from && v != c)
			{
				bool turn = 1;
				std::string tmp = cur_str;
				ops[v] = std::string(1, int_to_char(v)) + ops[v];
				for (auto &symb : ops[v])
				{
					tmp += symb;
					if (turn)
					{
						std::reverse(all(cur_str));
						tmp += (cur_str);
						std::reverse(all(cur_str));
					}
					else
					{
						tmp += (cur_str);
					}
					turn = !turn;
				}
				cur_str = tmp;
			}
		}
		dp[u] = cur;
		ops[u] = cur_str;

	};
	dfs(1, 1);
	cout << dp[1] << "\n";
	for (auto &sym : ops[1]) cout << char_to_int(sym) << " ";
	if(ops[1].size()) cout << "\n";
	return 0;
}